﻿using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.Enums;
using Kreta.Framework.Entities;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IAdatszotarDAL
    {
        void Delete(int felhasznaloId, int id, int typeId, int intezmenyId, int tanevId);
        void FollowUpDictionaryItemBase(int intezmenyId, int aktTanevId, int kovetkezoTanevId, int id);
        void GenerateNaptariNapok(int? intezmenyId, int? tanevId);
        IDictionaryItemBase Get(string type);
        IDictionaryItemBase Get(int id);
        DataSet GetAdatszotar(GeneratedAdatszotarTipusEnum type, int tanevId);
        DataSet GetAdatszotarById(int id, int intezmenyId, int tanevId);
        DataSet GetAdatszotarLathatoElemek(GeneratedAdatszotarTipusEnum adatszotarTipus, int tanevId, List<int> removeIdList = null);
        DataSet GetAdatszotarLathatoElemekNyelv(GeneratedAdatszotarTipusEnum type, int tanevId, int intezmenyId, int nyelvId);
        int GetAdatszotarMaxSorszam(GeneratedAdatszotarTipusEnum type, int tanevId, int intezmenyId);
        List<ICsoportTipus> GetCsoportTipusEntityList(int intezmenyId, int tanevId);
        Dictionary<int, List<EntityConnectionModel>> GetEntitiesConnections(int entityId, string entitasNev, int tanevId);
        void Insert(IDictionaryItemBase dto);
        bool IsProtected(int id, int tanevId);
        bool ModifyItemActivity(List<int> adatszotarIds, bool activ, int tanevId, out int szotartipusId);
        void Update(int id, string megnevezes, string megnevezes1, string megnevezes2, string megnevezes3, string megnevezes4, bool? lathato, bool isProtected, string color, int userId, int intezmenyId, int tanevId);
        void UpdateCsoportTipus(int id, bool isTanoraiCelu, int oraPerc, int intezmenyId, int tanevId, int userId);
        void UpdateNapTipus(int id, bool isSorszamozando, bool isTanorai, bool isTanorankivuli, bool isLeNemKotottMunkaido, int intezmenyId, int tanevId, int userId);

        void UpdateSorolasOkaTipus(int id, bool isBizonyitvanybanMegjelenik, bool isNaplobanMegjelenik, bool isTorzslaponMegjelenik, int intezmenyId, int tanevId, int felhasznaloId);
        void UpdateRendszerbeallitasok(int intezmenyId, int tanevId, RendszerBeallitasTipusEnum beallitasTipus, GeneratedAdatszotarTipusEnum dictionaryType);
        void UpdateSorszam(int id, int sorszam, int userId, int intezmenyId, int tanevId);
        void UpdateErtekelesModTipus(int intezmenyId, int tanevId, int userId, int id, bool isBold, int suly);
        List<(int id, string megnevezes)> GetEditableAdatszotarTipusok(int tanevId);
        int? GetEgyediKovTanevSzotarelemIdByKovTanevIdAndAktTanevSzotarelemId(int tanevId, int id);
    }
}
