﻿using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    /// <summary>
    /// CRUD alap interface a Dal-okhoz.
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public interface IBaseDal<T>
        where T : IEntity
    {
        /// <summary>
        /// Visszaad egy új entitást
        /// </summary>
        T Get();
        T Get(int id);
        void Insert(T dto);
        void Update(T dto);
        void Delete(T dto);
        void Delete(int id);
    }
}
