﻿using System;
using Kreta.Core.ConnectionType;

namespace Kreta.DataAccessManual.Interfaces
{
    internal interface IConnectionHandler
    {
        void Run(string sessionId, Action<IDalHandler> actions);
        T Run<T>(string sessionId, Func<IDalHandler, T> actions);
    }

    public interface IOrganizationConnectionHandler
    {
        void Run(string intezmenyAzonosito, Action<IDalHandler> actions);
        T Run<T>(string intezmenyAzonosito, Func<IDalHandler, T> actions);
    }

    public interface IMobileConnectionHandler
    {
        void Run(string intezmenyAzonosito, int? tanevId, Action<IDalHandler> actions, int? felhasznaloId = null);
        T Run<T>(string intezmenyAzonosito, int? tanevId, Func<IDalHandler, T> actions, int? felhasznaloId = null);
    }

    public interface ISystemConnectionHandler
    {
        void Run(Action<IDalHandler> actions);
        T Run<T>(Func<IDalHandler, T> actions);
    }

    public interface IServiceSystemConnectionHandler
    {
        void Run(string connectionString, Action<IDalHandler> actions);
        T Run<T>(string connectionString, Func<IDalHandler, T> actions);
    }

    public interface ICustomConnectionHandler
    {
        void Run(IConnectionType connectionType, Action<IDalHandler> actions);
        T Run<T>(IConnectionType connectionType, Func<IDalHandler, T> actions);
    }
}
