﻿using System;
using System.Data;
using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ICsengetesiRendDal
    {
        DataSet GetCsengetesiRendek(DateTime kezdoDatum, DateTime vegDatum, int? osztalycsoportszuro, int intezmenyId, int tanevId);
        DataSet GetCsengetesiRendek(int tanevId);
        DataSet GetCsengetesiRendEsOrak(string csengetesiRendId, int oraszamId, int tanevId);
        DataSet GetCsengetesiRendekByMukodesiHely(int tanevId, int? mukodesiHelyId = default(int?), bool csakAktiv = false);
        void SetCsengetesirend(int csengetesiRendId, bool aktiv, int tanevId);
        ICsengetesiRend Get();
        ICsengetesiRend Get(int id);
        void FullUpdate(ICsengetesiRend dto);
        void Update(ICsengetesiRend dto);
        void Insert(ICsengetesiRend dto);
        void Delete(int id);
        (int csengetesiRendId, int oraSzam) GetCsengetesiRendAndOraszam(int csengetesirendId, int intezmenyId, int tanevId);
        int GetAktivCsengetesiRendId(int tanevId, int intezmenyId);
        bool IsCsengetesiRendNevExists(int id, string nev, int tanevId);
        void FollowUpCsengetesiRend(int intezmenyId, int aktTanevId, int kovetkezoTanevId, int csengetesiRendId);
        (int minOraszam, int maxOraszam) GetMinMaxOraszam(int tanevId, int csengetesirendId);
    }
}
