﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.DataAccessObjects.Csoport;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ICsoportDal
    {
        List<NemTanoraiCeluCsoportTipusDao> GetNemTanoraiCeluCsoportTipusList();
        DataSet CsoportKereses(int tanevId, int intezmenyId, CsoportSearchPco pco);
        void SetOsztalyBontasIdToNull(int csoportId, int userId, int tanevId);
        void Delete(ICsoport dto, int intezmenyId, int tanevId, bool updateTanoraEvesSorszam = true);
        void Delete(int id, int intezmenyId, int tanevId, bool updateTanoraEvesSorszam = true);
        ICsoport Get();
        ICsoport Get(int id);
        int GetCsoportAktualisLetszam(int csopId);
        DataSet GetCsoportokForDDL(OktNevelesiKategoriaEnum? feladatKategoria = null, int? tanarId = null);
        DataSet GetOsztalyCsoportTanulok(int id, DateTime? datum, string intezmenyAzonosito, DateTime? tanevElsoNapja = null, bool? isGroupedByKilepesDatum = false);
        DataSet GetOsztalyCsoportTanulokEsFelmenteseik(int osztalyCsoportId, DateTime? datum, int? tanuloId, int? tantargyId, string intezmenyAzonosito);
        DataSet GetTanoranKivuliCsoportokForDDL(int tanevId, int intezmenyId);
        DataSet GetNapkozisCsoportokForDDL(int? tanarId = default(int?));
        DataSet GetOsztalybontasosCsoportok(int osztalyId, int tanevId);
        DataSet GetSzakmaiGyCsoportokForDDL(int? tanarId = default(int?));
        DataSet GetTanuloSorolasData(int tanuloId, int id);
        int Insert(ICsoport dto);
        void Update(ICsoport dto, bool updateTanoraEvesSorszam = true);
        DataSet GetCsoportDataSet(int tanevId, int? oktNevelesiKategoriaId = null);
        bool IsNyariSzakmaiGyakorlatos(int tanevId, int csoportId);
        DataSet GetOsszefuggoSzakGyakosCsoportok(int tanevId);
        DataSet GetEgyeniCsoportData(int tanuloId, int osztalyId, int selectedTanevId, IEnumerable<int> amiEgyeniCsoportok, bool isKovTanev, DateTime? kovTanevElsoNapja);
        bool IsEgyeniCsoportNevLetezik(int tanuloId, string osztalyNev, int tanevId);
        void UpdateTTFFoglalkozasTipusByCsoportTipus(int tanevId, int csoportId, int csoportTipusId, bool isBontott, int modifierId);
        DataSet GetOsztalyIdByCsoportIdAndDatum(int tanevId, int intezmenyId, int csoportId, DateTime datum);
        DataSet GetCsoportMunkarendSzama(int csoportId, bool isAktivTanev);
        DataSet GetCsoportTanuloiByMunkarend(int osztalycsoportId, bool hasMunkarend, bool isAktivTanev);
    }
}
