﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;
using Kreta.Enums.ManualEnums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IDKT_FeladatDal
    {
        IDKT_Feladat Get();

        IDKT_Feladat Get(int id);

        void FullUpdate(IDKT_Feladat dto);

        void Update(IDKT_Feladat dto);

        DataSet GetAllSchemaHazifeladatNotification();

        void SetHazifeladatAsKikuldott(List<int> idList);

        DataSet GetFeladatokByDateRange(int intezmenyId, int tanevId, DateTime start, DateTime end, int? feladatTipus);

        bool HasOrarendiOraKapcsolodoHazifeladatot(int tanevId, int orarendiOraGroupId, DateTime oraErvenyessegKezdete, DateTime oraErvenyessegVege, bool idoszakonKivul = true);

        DataSet GetHaziFeladatForOrarendiOra(int orarendiOraId, DateTime? date, int? oraszam, OktNevelesiKategoriaEnum? kategoria, int feladatTipusId = (int)FeladatTipusEnum.HaziFeladat);

        DataSet GetHaziFeladatForTanitasiOra(int tanitasiOraId, OktNevelesiKategoriaEnum? kategoria, int feladatTipusId = (int)FeladatTipusEnum.HaziFeladat);

        DataSet GetTanuloHaziFeladat(int intezmenyId, int? tanevId, int tanuloId, OktNevelesiKategoriaEnum? feladatKategoria, TanuloHaziFeladatSearchPCO pco);
    }
}
