﻿using Kreta.Framework.Util;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IDalHandler
    {
        bool CommitOnEnd { get; }
        IAdatszolgaltatasENaploDal AdatszolgaltatasENaploDal();
        IAdatszolgaltatasokDal AdatszolgaltatasokDAL();
        IAdatszolgaltatasokDal AdatszolgaltatasokDAL(GridParameters parameters);
        IAdatszotarDAL AdatszotarDAL();
        IAdatszotarDAL AdatszotarDAL(GridParameters parameters);
        IDictionaryItemBaseNyelvDal DictionaryItemBaseNyelvDal();
        IDictionaryItemBaseNyelvDal DictionaryItemBaseNyelvDal(GridParameters parameters);
        IAdminDAL Admin();
        IAdminDAL Admin(GridParameters parameters);
        IAlkalmazottDal Alkalmazott();
        IAlkalmazottDal Alkalmazott(GridParameters parameters);
        IAlkalmazottMunkaugyiAdatokDal AlkalmazottMunkaugyiAdatokDal();
        ICimDal Cim();
        ICsengetesiRendDal CsengetesiRend();
        ICsengetesiRendDal CsengetesiRend(GridParameters parameters);
        ICsengetesiRendOrakDal CsengetesiRendOrak();
        ICsengetesiRendOrakDal CsengetesiRendOrak(GridParameters parameters);
        ICsoportDal Csoport();
        ICsoportDal Csoport(GridParameters parameters);
        IDashboardUzenetDal DashboardUzenet();
        IDiakolimpiaDAL DiakolimpiaDAL();
        IDiakolimpiaDAL DiakolimpiaDAL(GridParameters parameters);
        IDokumentumDal DokumentumDal();
        IElearningElerhetosegDal ElearningElerhetosegDal();
        IEletpalyaModellDal EletpalyaModell();
        IEmailDal Email();
        IEmailDal Email(GridParameters parameters);
        IErettsegiEredmenyDal ErettsegiEredmeny();
        IErettsegiEredmenyDal ErettsegiEredmeny(GridParameters parameters);
        IEszkozDal EszkozDal();
        IEszkozDal EszkozDal(GridParameters parameters);
        IEszkozigenylesDal EszkozigenylesDal();
        IEszkozigenylesDal EszkozigenylesDal(GridParameters parameters);
        IEugyintezesDal EugyintezesDal();
        IEugyintezesLogDal EugyintezesLog();
        IFeladatEllatasiHelyDal FeladatEllatasiHelyDal();
        IFeladatEllatasiHelyDal FeladatEllatasiHelyDal(GridParameters parameters);
        IFelhasznaloDal Felhasznalo();
        IFelhasznaloDal Felhasznalo(GridParameters parameters);
        IFelhasznaloBelepesDal FelhasznaloBelepes();
        IFeljegyzesDal Feljegyzes();
        IFeljegyzesDal Feljegyzes(GridParameters parameters);
        IFeltoltottFajlDAL FeltoltottFajlDAL();
        IFeltoltottFajlDAL FeltoltottFajlDAL(GridParameters parameters);
        IFileDAL FileDAL();
        IFileDAL FileDAL(GridParameters parameters);
        IFogadooraDal Fogadoora();
        IFogadooraDal Fogadoora(GridParameters parameters);
        IFoglalkozasDal Foglalkozas();
        IFoglalkozasDal Foglalkozas(GridParameters parameters);
        IFoglalkozasAmiTanuloDal FoglalkozasAmiTanuloDal();
        IFoglalkozasAmiTanuloDal FoglalkozasAmiTanuloDal(GridParameters parameters);
        IGondviseloDal Gondviselo();
        IBeszerzesiModulDAL BeszerzesiModul();
        IBeszerzesiModulDAL BeszerzesiModul(GridParameters parameters);
        IHelyettesitesDAL HelyettesitesDAL();
        IHelyettesitesDAL HelyettesitesDAL(GridParameters parameters);
        IHetesDal HetesDal();
        IHRModulDAL HRModulDAL();
        IHRModulDAL HRModulDAL(GridParameters parameters);
        IIgazolasDal IgazolasDal();
        IIgazolasDal IgazolasDal(GridParameters parameters);
        IIktatottDokumentumCsatolmanyDal IktatottDokumentumCsatolmanyDal();
        IIktatottDokumentumDal IktatottDokumentumDal();
        IIktatottDokumentumDal IktatottDokumentumDal(GridParameters parameters);
        IImportExportDal ImportExportDal();
        IImportExportDal ImportExportDal(GridParameters parameters);
        IInformatikaiAdatszolgDal InformatikaiAdatszolgDal();
        IInformatikaiAdatszolgDal InformatikaiAdatszolgDal(GridParameters parameters);
        IIntezmenyAdatokDal IntezmenyAdatokDal();
        IIntezmenyAdatszolgaltatasDal IntezmenyAdatszolgaltatasDal();
        IIntezmenyDal IntezmenyDal();
        IJelszoModositasLinkDal JelszoModositasLinkDal();
        IJelszoModositasLinkDal JelszoModositasLinkDal(GridParameters parameters);
        IKepesitesDal KepesitesDal();
        IKepesitesDal KepesitesDal(GridParameters parameters);
        IKirKontenerDAL KirKontenerDAL();
        IKirKontenerElemDAL KirKontenerElemDAL();
        IKirKontenerElemStatuszDAL KirKontenerElemStatuszDAL();
        IKirKontenerStatuszDAL KirKontenerStatuszDAL();
        IKirStatDAL KirStatDAL(GridParameters parameters);
        IKirTelephelyDal KirTelephelyDal();
        IKKVegzettsegDal KKVegzettsegDal();
        IKKVegzettsegDal KKVegzettsegDal(GridParameters parameters);
        IKozmuszamlaDal KozmuszamlaDal();
        IKozmuszamlaDal KozmuszamlaDal(GridParameters parameters);
        ILepEloadasDal LepEloadasDal();
        ILepEloadasDal LepEloadasDal(GridParameters parameters);
        ILepEloadasJegyzekDal LepEloadasJegyzekDal();
        ILepEloadasJegyzekDal LepEloadasJegyzekDal(GridParameters parameters);
        IMeroallasDal MeroallasDal();
        IMeroallasDal MeroallasDal(GridParameters parameters);
        IMerohelyDal MerohelyDal();
        IMerohelyDal MerohelyDal(GridParameters parameters);
        IMukodesiHelyDAL MukodesiHelyDAL();
        IMukodesiHelyDAL MukodesiHelyDAL(GridParameters parameters);
        IMulasztasDal MulasztasDal();
        IMulasztasDal MulasztasDal(GridParameters parameters);
        INaploEllenorzesDal NaploEllenorzes();
        INaploEllenorzesDal NaploEllenorzes(GridParameters parameters);
        INaptariHetDal NaptariHet();
        INaptariHetDal NaptariHet(GridParameters parameters);
        INaptariNapDal NaptariNap();
        INaptariNapDal NaptariNap(GridParameters parameters);
        INatKerdoivDal NatKerdoivDal();
        INatKerdoivDal NatKerdoivDal(GridParameters parameters);
        INebuloDal Nebulo();
        INebuloDal Nebulo(GridParameters parameters);
        INemKotottMunkaidoDal NemKotottMunkaido();
        INemKotottMunkaidoDal NemKotottMunkaido(GridParameters parameters);
        INyomtatvanyokDal NyomtatvanyokDal();
        INyomtatvanyokDal NyomtatvanyokDal(GridParameters parameters);
        IOktatasNevelesiFeladatDal OktatasNevelesiFeladatDal();
        IOralatogatasDal OralatogatasDal();
        IOralatogatasDal OralatogatasDal(GridParameters parameters);
        IOrarendiOraDal OrarendiOra();
        IOrarendiOraDal OrarendiOra(GridParameters parameters);
        IOraSorszamozasHalmazDAL OraSorszamozasHalmaz();
        IOraSorszamozasHalmazDAL OraSorszamozasHalmaz(GridParameters parameters);
        IOraSorszamozasHalmazOsszerendelesDal OraSorszamozasHalmazOsszerendeles();
        IOratervDal OratervDal();
        IOratervDal OratervDal(GridParameters parameters);
        IOsszefuggoSzakGyakDal OsszefuggoSzakGyakDal();
        IOsszefuggoSzakGyakDal OsszefuggoSzakGyakDal(GridParameters parameters);
        IOsztalyDal Osztaly();
        IOsztalyDal Osztaly(GridParameters parameters);
        IOsztalyCsoportDal OsztalyCsoport();
        IOsztalyCsoportDal OsztalyCsoport(GridParameters parameters);
        IOraFileDAL OraFile();
        IPedagogusIKTAdatszolgaltatasDal PedagogusIKTAdatszolgaltatasDal();
        IRendszerBeallitasDAL RendszerBeallitas();
        IRendszerBeallitasDAL RendszerBeallitas(GridParameters parameters);
        IRolesDAL RolesDAL();
        ISapTavolletDal SapTavolletDal();
        ISzamonkeresElorejelzesDal SzamonkeresElorejelzes();
        ISzamonkeresElorejelzesDal SzamonkeresElorejelzes(GridParameters parameters);
        ISzerepkorDAL Szerepkor();
        ISzerepkorDAL Szerepkor(GridParameters parameters);
        ITanarDal TanarDal();
        ITanarDal TanarDal(GridParameters parameters);
        ITanariAtlagSulyDal TanariAtlagSulyDal();
        ITanariAtlagSulyDal TanariAtlagSulyDal(GridParameters parameters);
        ITanevDal TanevDal();
        ITanevDal TanevDal(GridParameters parameters);
        ITanevRendjeDal TanevRendjeDal();
        ITanevRendjeDal TanevRendjeDal(GridParameters parameters);
        ITanitasiOraDal TanitasiOra();
        ITanitasiOraDal TanitasiOra(GridParameters parameters);
        ITanmenetDal Tanmenet();
        ITanmenetDal Tanmenet(GridParameters parameters);
        ITantargyDal Tantargy();
        ITantargyDal Tantargy(GridParameters parameters);
        ITantargyFelosztasDal TantargyFelosztas();
        ITantargyFelosztasDal TantargyFelosztas(GridParameters parameters);
        ITantervDAL TantervDAL();
        ITantervDAL TantervDAL(GridParameters parameters);
        ITanuloDal Tanulo();
        ITanuloDal Tanulo(GridParameters parameters);
        ITanuloCsoportDal TanuloCsoport();
        ITanuloErtekelesDal TanuloErtekelesDal();
        ITanuloErtekelesDal TanuloErtekelesDal(GridParameters parameters);
        ITanuloErtekelesMondatbankDal TanuloErtekelesMondatbankDal();
        ITanuloErtekelesMondatbankDal TanuloErtekelesMondatbankDal(GridParameters parameters);
        ITanuloErtekelesNyelvDal TanuloErtekelesNyelvDal();
        ITanuloKozossegiSzolgalatDal TanuloKozossegiSzolgalat();
        ITanuloKozossegiSzolgalatDal TanuloKozossegiSzolgalat(GridParameters parameters);
        ITanuloMentessegDal TanuloMentesseg();
        ITanuloTanugyiAdatokDal TanuloTanugyiAdatokDal();
        ITanuloTanugyiAdatokDal TanuloTanugyiAdatokDal(GridParameters parameters);
        ITelefonDal Telefon();
        ITelepulesDal TelepulesDal();
        ITelepulesDal TelepulesDal(GridParameters parameters);
        ITeremDal Terem();
        ITeremDal Terem(GridParameters parameters);
        ITeremElerhetosegDal TeremElerhetoseg();
        ITeremElerhetosegDal TeremElerhetoseg(GridParameters parameters);
        ITeremFeltoltottFajlDal TeremFeltoltottFajlDal();
        ITovabbiMunkaugyiAdatokDal TovabbiMunkaugyiAdatok();
        ITovabbiMunkaugyiAdatokDal TovabbiMunkaugyiAdatok(GridParameters parameters);
        IVegzettsegDal VegzettsegDal();
        IDKT_FeladatDal DKT_FeladatDal();
        IDKT_FeladatDal DKT_FeladatDal(GridParameters parameters);
        IDKT_FileDAL DKT_FileDAL();
        IDKT_FileDAL DKT_FileDAL(GridParameters parameters);
        IJuttatasDal JuttatasDAL();
        ITanuloSniDal TanuloSniDal();
        ITovabbkepzesDal TovabbkepzesDal();
        IBankszamlaIgenylesDal BankszamlaIgenylesDal();
        IJogviszonySzuneteltetesDal JogviszonySzuneteltetesDal();
        IKirSzirFeladatellatasiHelyDAL KirSzirFeladatellatasiHelyDAL();
        IKirSzirFeladatellatasiHelyDAL KirSzirFeladatellatasiHelyDAL(GridParameters parameters);
        ISzirStatFileDAL SzirStatFileDAL();
        ISzirStatFileDAL SzirStatFileDAL(GridParameters parameters);
        IIntezmenyConfigDAL IntezmenyConfigDAL();
        IZaradekDal ZaradekDal();
        IDualisSzerzodesFileDal DualisSzerzodesFileDal();
        IDualisSzerzodesFileDal DualisSzerzodesFileDal(GridParameters parameters);
        ILeptetesDal Leptetes();
        ILeptetesDal Leptetes(GridParameters parameters);
        ISZIRAdatszolgDAL SZIRAdatszolgDAL();
        IFelmentesDal FelmentesDal();
        IFelmentesDal FelmentesDal(GridParameters parameters);
        IMunkaszerzodesDal MunkaszerzodesDal();
        IMunkaszerzodesDal MunkaszerzodesDal(GridParameters parameters);
        ITbJogviszonyDal TbJogviszonyDal();
        ISzervezetDal SzervezetDal();
        ISzervezetDal SzervezetDal(GridParameters parameters);
        IUjSzktSzakmajegyzekOsszerendelesDal UjSzktSzakmajegyzekOsszerendelesDal();
        IUjSzktSzakmajegyzekOsszerendelesDal UjSzktSzakmajegyzekOsszerendelesDal(GridParameters parameters);
        ISzakkepzesiMunkaszerzodesDAL SzakkepzesiMunkaszerzodesDAL();
    }
}
