﻿using System;
using System.Data;
using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IDashboardUzenetDal : IBaseDal<IDashboardUzenet>
    {
        /// <summary>
        /// Visszaadja a Login ablakban megjelenítendő üzenetet (következő telepítés ideje).
        /// </summary>
        /// <returns></returns>
        DataSet GetLoginDashboardUzenet();

        /// <summary>
        /// Visszaadja az admin Dashboard-on megjeleníthető üzeneteket.
        /// </summary>
        /// <returns></returns>
        DataSet GetAdminDashboardUzenetDataSet(int felhasznaloId);

        /// <summary>
        /// Visszaadja a tanár Dashboard-on megjeleníthető üzeneteket.
        /// </summary>
        /// <returns></returns>
        DataSet GetTanarDashboardUzenetDataSet(int felhasznaloId);

        /// <summary>
        /// FIXME: még nem pont ezt csinálja!!!
        /// Visszaadja az adott intézmény intézmény-specifikus üzenetek egyedi azonosítóját.
        /// </summary>
        /// <param name="intezmenyId"></param>
        /// <returns></returns>
        DataSet GetDashboardEgyediAzonositokByIntezmeny(int intezmenyId);

        /// <summary>
        /// Visszaadja adott feature alapján, hogy ahhoz éppen érvényben van-e "karbantartás".
        /// </summary>
        /// <param name="feature">A feautre neve a Core.Constants.FeatureName -ból.</param>
        /// <returns></returns>
        DataSet GetFeatureMaintenanceDashboardUzenet(string feature);

        /// <summary>
        /// Visszaadja adott felhasználónak az egyediAzonosito alapján az adott DashboardUzenet-et.
        /// </summary>
        DataSet GetDashboardUzenetForPopup(int felhasznaloId, int? gondviseloId, int popupId, string egyediAzonosito);

        /// <summary>
        /// Visszaadja az adott felhasználóhoz tartozó DashboardUzenet-ek közül az elsőt,
        /// ami még nem jelent meg az aktuális session-ben.
        /// </summary>
        /// <param name="felhasznaloId"></param>
        /// <param name="gondviseloId">Ha gondviselő lép be, akkor van benne érték.</param>
        /// <param name="displayedPopups">Az aktuális session alatt már megjelenített popup üzenetek listája.</param>
        /// <returns></returns>
        DataSet GetNextDashboardPopup(int felhasznaloId, int? gondviseloId, string[] displayedPopups);

        /// <summary>
        /// Az adott DashboardUzenetFelhasznalo (popup) rekord megtekintéseinek a számát eggyel csökkenti.
        /// </summary>
        /// <param name="popupId"></param>
        void UpdateDashboardPopupClose(int popupId);

        /// <summary>
        /// Az adott DashboardUzenetFelhasznalo (popup) rekord megtekintéseinek a számát 0-ra (!) módosítja.
        /// </summary>
        /// <param name="felhasznaloId"></param>
        /// <param name="egyediAzonosito"></param>
        void UpdateDashboardPopupConfirm(int popupId);

        /// <summary>
        /// Az adott DashboardUzenetFelhasznalo (popup) rekord megtekintéseinek a számát 0-ra (!) módosítja,
        /// majd visszatér egy url string-el.
        /// </summary>
        /// <param name="popupId"></param>
        /// <returns></returns>
        string UpdateDashboardPopupNext(int popupId);

        DateTime GetKovTelepitesDatum();
    }
}
