﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IFelhasznaloBelepesDal
    {
        void GrantLogin(int felhasznaloId, string bejelentkezesiNev, string plainPassword, int tanevId, int? gondviseloId = null, bool storedplain = false, int? intezmenyId = null, bool kotelezoValtoztatni = false);

        void Delete(int id);
        void FullUpdate(IFelhasznaloBelepes dto);
        IFelhasznaloBelepes Get();
        IFelhasznaloBelepes Get(int id);
        DataSet Get(string felhasznaloNev);
        DataSet GetFehasznaloBelepesDataSet(int tanevId);
        List<IFelhasznaloBelepes> GetFelhasznaloBelepesei(string generaltBejelentkezesiNev, int tanevId);
        void Insert(IFelhasznaloBelepes dto);
        void Update(IFelhasznaloBelepes dto);
        void UpdateFelhasznalonev(int intezmenyId, int tanevId, int modifierId, int tanuloId, int? gondviseloId, string felhasznalonev);
        void UpdateLastLogin(int felhasznaloBelepesId, DateTime lastLogin);
        void UpdateMeghiusultBelepesek(int felhasznaloBelepesId, int meghiusultBelepesek);
        bool IsUserNameExistsInTanev(string userName, int tanevId, int? felhasznaloId = null, bool isgondviselo = false);
        int? IsUserNameExistsInIntezmeny(string userName, int intezmenyId, int? felhasznaloId = null, bool isgondviselo = false);
        void UpdateLastLoginByUserId(int userId, DateTime lastLogin, bool isGondviselo);
    }
}
