﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.DataAccessObjects.Feljegyzes;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IFeljegyzesDal
    {
        void AddOsztalyCsoport(ITanuloEsemeny entity, int osztalyCsoportId);
        void AddTanulo(ITanuloEsemeny entity, int tanuloId);
        bool CheckUgyiratszamExists(string ugyiratszam);
        void Delete(ITanuloEsemeny dto);
        void DeleteBeiras(int id, int tanuloId);
        void DeleteBeirasNyelv(int Id);
        void DeleteElektronikusUzenetForTanulo(int id, int tanuloId);
        void DeleteFeljegyzes(int id);
        DataSet FaliujsagKereses(FeljegyzesekKeresesePCO feljegyzesekKeresesePCO);
        DataSet FeljegyzesekKereses(FeljegyzesekKeresesePCO feljegyzesekKeresesePCO, int intezmenyId);
        void FullUpdate(ITanuloEsemeny dto);
        ITanuloEsemeny Get();
        ITanuloEsemeny Get(int id);
        ITanuloEsemenyNyelv GetBeirasNyelv();
        DataSet GetFaliujsagExcelExport(FeljegyzesekKeresesePCO feljegyzesekKeresesePCO);
        DataTable GetFaliujsagonMegjelenoBejegyzesek(int userId, DateTime? date, OktNevelesiKategoriaEnum? feladatKategoria, int? startindex = null, int? count = null);
        DataSet GetFeljegyzesBeirasokData(int intezmenyId, int tanevId, int osztalyCsoportId, DateTime startDate, int tanarId);
        DataSet GetFeljegyzesBeirasokReszletek(int intezmenyId, int? tanevId, int tanuloId, int tanarId, bool toroltElemek);
        DataSet GetFeljegyzesElektronikusUzenetekListaNezetData(int intezmenyId, int tanevId, int osztalyCsoportId, int tanarId);
        DataSet GetFeljegyzesElektronikusUzenetekModifyPopupData(int osztalyCsoportId);
        DataSet GetFeljegyzesElektronikusUzenetekNaploNezetData(int intezmenyId, int tanevId, int osztalyCsoportId, DateTime startDate, int tanarId);
        DataSet GetFeljegyzesElektronikusUzenetekNaploNezetReszletek(int intezmenyId, int? tanevId, int tanuloId, int tanarId, bool toroltElemek);
        DataSet GetFeljegyzesFaliujsagBejegyzesekData(int tanarId, int esemenyTipusFaliujsagBejegyzesId);
        DataSet GetFeljegyzesFaliujsagBejegyzesekPopupData();
        List<int> GetFogadooraByFeljegyzesId(int feljegyzesId);
        Dictionary<int, bool> GetIsFeljegyzeshezTartozoOsztalyAlapkepzesesByFeljegyzesIdDictionary(List<int> feljegyzesIdFilters);
        DataSet GetLegutobbiFeljegyzesek(int tanuloId);
        ITanuloEsemeny GetSpecific(string condition, int tanevId);
        DataSet GetTanuloFeljegyzesei(int tanuloId, DateTime? fromDate = null, DateTime? toDate = null, int? id = null, OktNevelesiKategoriaEnum? feladatKategoria = null);
        DataSet GetAllSchemaRendszeruzenetFeljegyzesNotification();
        void SetFeljegyzesAsKikuldott(IEnumerable<int> idList);
        List<FeljegyzesDao> GetAllSchemaFeljegyzesNotification();
        void Insert(ITanuloEsemeny dto);
        void InsertBeirasNyelv(ITanuloEsemenyNyelv dto);
        void RemoveOsztalyCsoport(ITanuloEsemeny entity, int osztalyCsoportId);
        void RemoveTanulo(ITanuloEsemeny entity, int tanuloId);
        void SetFeljegyzesAsKikuldott(int feljegyzesId);
        void UpdateBeirasNyelv(ITanuloEsemenyNyelv dto);
    }
}
