﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums.ManualEnums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IFogadooraDal
    {
        void DeleteFogadoora(int id);
        void DeleteFogadooraIdopontGondviselo(int id);
        DataSet DeleteFogadooraIdopontGondviseloByFogadooraIdOsztalyCsoportId(int fogadooraId, int osztalyCsoportId);
        void DeleteFogadooraOsztalyCsoportByFogadooraId(int fogadooraId);
        void DeleteFogadooraOsztalyCsoportByFogadooraIdOsztalyCsoportId(int fogadooraId, int osztalyCsoportId);
        void DeleteOsztalyCsoportTanuloesemenyByFogadooraId(int fogadooraId, int osztalyCsoportId);
        void FullUpdate(IFogadoora dto);
        void FullUpdate(IFogadooraIdopont dto);
        IFogadoora Get();
        IFogadoora Get(int id);
        DataSet GeTeremOrarendDataSet(int intezmenyId, int tanevId, DateTime start, DateTime end, int teremId);
        DataSet GetFogadoora(int intezemenyId, int tanevId, FogadooraSearchPco searchPco);
        DataSet GetFogadooraById(int fogadooraId, int gondviseloId);
        DataSet GetTanarFogadoorakByGondviseloId(int gondviseloId, int? fogadoOraId = null, DateTime? datumTol = null, DateTime? datumIg = null);
        DataSet GetFogadooraCalendar(int intezemenyId, int tanevId, DateTime? start, DateTime end, int? tanarId);
        DataSet GetFogadooraForGondviseloCalendar(int intezemenyId, int tanevId, DateTime? start, DateTime end, int? tanuloId);
        DataSet GetFogadooraGondviselo(int intezemenyId, int tanevId, int gondviseloId, int? tanarId = null, int? teremId = null, DateTime? start = null, DateTime? end = null, DateTime? startTime = null, DateTime? endTime = null, bool? isJelentkezheto = null);
        List<(int Id, DateTime Idopont)> GetFogadooraIdByGroupIdList(int tanevId, int fogadooraGroupId, DateTime start, DateTime end);
        IFogadooraIdopont GetFogadooraIdopont();
        IFogadooraIdopont GetFogadooraIdopont(int id);
        IFogadooraIdopont_Gondviselo GetFogadooraIdopontGondviselo();
        IFogadooraIdopont_Gondviselo GetFogadooraIdopontGondviselo(int id);
        DataSet GetFogadooraIdopontok(List<int> fogadooraIds, int gondviseloId, FogadooraTipusEnum? tipus = null);
        DataSet GetFogadooraIdopontokByRendszeressegTipusId(int tanevId, int rendszeressegTipusId, DateTime datum, DateTime tanevUtolsoNapja);
        DataSet GetFogadooraJelentkezettGondviselokByGroupId(int groupId, DateTime kedzete, DateTime vege);
        DataSet GetFogadooraJelentkezettGondviselokDataSet(int fogadooraId, List<int> fogadooraOsztalyCsoportIdList);
        DataSet GetFogadooraNotifications();
        IFogadoora_OsztalyCsoport GetFogadooraOsztalyCsoport();
        DataTable GetFogadooraOsztalyCsoportMaradekElemek(int fogadooraId);
        DataSet GetFogadooraOsztalyCsoportok(int tanevId, int tanarId, bool isSzuperOsztalyfonok);
        DataSet GetGondviselokByFogadooraId(int fogadooraId);
        DataSet GetGondviselokByFogadooraIdAndOsztalyCsoportId(int fogadooraId, int? osztalyCsoportId);
        DataSet GetGondviseloKozelgoFogadoora(int tanevId, int nap);
        DataSet GetJelentkezettGondviseloCntByFogadooraId(int fogadooraId);
        DataSet GetJelentkezettGondviselokByFogadooraId(int fogadooraId);
        DataSet GetPedagogusOrarendDataSet(int intezmenyId, int tanevId, DateTime start, DateTime end, int tanarId);
        DataSet GetPedagogusTeremFogadooraDataSet(int tanevId, DateTime start, DateTime end, int? tanarId = null, int? teremId = null);
        string GetProfileData(int felhasznaloId);
        int Insert(IFogadoora dto);
        int Insert(IFogadoora_OsztalyCsoport dto);
        int Insert(IFogadooraIdopont dto);
        void Insert(IFogadooraIdopont_Gondviselo dto);
        void InsertOsztalyCsoportTanuloesemenyByFogadooraId(int fogadooraId, int osztalyCsoportId);
        bool IsSzabadIdopontByFogadooraIdopontId(int fogadooraIdopontId);
        void UpdateFogadooraGroupId(int fogadooraId, int groupId);
        DataSet GetKozelgoFogadoorak();
        DataSet GetFogadooraDokumentumAdatok(int fogadooraId, int tanevId);
        bool IsFogadooraJelentkezesFeatureEnabled(int fogadooraIdopontId);
    }
}
