﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IFoglalkozasDal
    {
        void Delete(int id);
        void FullUpdate(IFoglalkozas dto);
        IFoglalkozas Get();
        IFoglalkozas Get(int id);
        DataSet GetFelhasznaloFoglalkozasokErtekelesekhez(int tanevId, int tanarId);
        DataSet GetErtekelesFotargyiFoglalkozasData(int tanevId, int tanarId);
        DataSet GetFoglalkozasok(int? tanarId, int tanevId);
        DataSet GetTantargyfelosztasDataSet(int intezmenyId, int tanevId, int? alkalmazottId = null, int? osztalyCsoportId = null, int? oktNevelesiKategoriaId = null, bool isOsztalybontasokkal = false, bool isKapcsolodoCsoportokkal = false, bool isFromSzervezet = false, int? szervezetId = null);
        DataSet GetFoglalkozasNev(int tanarId, int tantargyId, int osztalycsoportId, OktNevelesiKategoriaEnum? kategoria);
        DataTable GetFoglalkozasokMegtartandoOraSzama();
        int? GetFoglalkozasTipusByOsztalyCsoportTipus(int osztalyCsoportTipus, bool? isBontott);
        DataSet GetOsszesFoglalkozas(int tanevId, int? oktNevelesiKategoriaId = (int)OktNevelesiKategoriaEnum.NevelesOktatas);
        DataSet GetOsztalyCsoportFoglalkozasai(int osztalyCsoportId, int tanevId, OktNevelesiKategoriaEnum? kategoria);
        DataSet GetTanuloFoglalkozasai(int tanuloId, int osztalyId, int tanevId, bool egyeni, IEnumerable<int> amiEgyeniCsoportok, OktNevelesiKategoriaEnum? kategoria, DateTime tanevElsoNapja);
        DataSet GetTanarFoglalkozasok(int tanarId, int tanevId, string typeId = "");
        DataSet GetTanarNemTanitottFoglalkozasok(int tanarId, int tanevId);
        DataSet GetTanarFoglalkozasTipusok(int tanarId, int tanevId);
        DataSet GetTanarokTanoranKivuliFoglalkozashoz(int tanoranKivuliFoglalkozasId, int tanevId);
        DataSet GetTanoranKivuliFoglalkozasok(int? tanarId, int tanevId);
        void Insert(IFoglalkozas dto);
        void Update(IFoglalkozas dto);
        DataSet GetSablonok(int tanevId, int osztalyId);
        DataSet GetSablon(int sablonId);
        DataSet GetFoglalkozasOsszOraszamok(int tanevId, bool isFromSzervezet);
    }
}
