﻿using System;
using System.Collections.Generic;
using System.Data;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IHetesDal
    {
        DataSet GetHetSorszamokTanulokkal(int tanevId, int osztalyCsoportId, int? hetSorszam = null);

        DataSet GetHetesek(int tanevId, int osztalyCsoportId);

        void DeleteFutureHetesInOsztalyCsoport(int tanevId, int osztalyCsoportId);

        (List<int> toroltHetesek, List<int> beallitottHetesek) SaveOrDeleteHetesek(int tanevId, int osztalyCsoportId, int hetSorszam, List<int> selectedTanuloIds);

        string GetHetesekForDatum(int tanevId, int osztalyCsoportId, DateTime datum);

        void DeleteHetesekInIdoszak(int tanevId, int osztalyCsoportId, int tanuloId, DateTime? belepesDatum, DateTime? kilepesDatum);

        void DeleteHetesekNotInIdoszak(int tanevId, int osztalyCsoportId, int tanuloId, DateTime? belepesDatum, DateTime? kilepesDatum);

        DataSet GetHetesNevekHetsorszammal(int tanevId, List<int> osztalyCsoportIdList);

        DataSet GetHetesAdatokFeljegyzeshez(int tanevId, int osztalyCsoportId, List<int> selectedTanuloIds, bool IsTorolt);
    }
}
