﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.Ellenorzo.Dao.VN.Intezmeny.Rendszermodul;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IIntezmenyDal
    {
        void FollowUpIntezmenyAdatok(int intezmenyId, int aktTanevId, int kovetkezoTanevId);
        IIntezmeny Get(int id);
        DataSet GetAktivIntezmenyNevCim(string intezmenyAzonosito);
        DateTime? GetFrissitesDatum();
        int? GetIntezmenyAdatokIdByAzonosito(string azonosito);
        DataSet GetIntezmenyek();
        int GetIntezmenyId(string intezmenyAzonosito);
        DataSet GetIntezmenyIdAktivTanevIdByAzonosito(string azonosito);
        int? GetIntezmenyIdByAzonosito(string azonosito);
        DataSet GetIntezmenyIdAndNevByAzonosito(string azonosito);
        string GetIntezmenyNevById(int intezmenyId, int tanevId);
        DataSet GetIntezmenyAdatok(int intezmenyId, int tanevId);
        DataSet GetIntezmenyItmAdatszolgaltatasAdatok(int intezmenyId, int tanevId);
        DataSet GetIntIdAndTanevIdByIntezmenyadatokId(int id);
        DataSet GetIntIdAndTanevNevByIntezmenyadatokId(int id);
        string GetNeptunNaploLink(int intezmenyId);
        string GetNexiusId(int intezmenyId);
        DataSet GetOrganizationIdentyNameWithOmCode(bool x);
        string GetOrganizationSystemSettingsJSON();
        List<string> GetOsszesIntezmeny();
        string GetPoszeidonBejelentkezesiNev(int intezmenyId);
        RendszermodulListResponseDao GetRendszermodulDao(int intezmenyAdatokId);
        DataSet GetTelephelyAnyaintezmenyList(int tanevId);
        void Insert(IIntezmenyAdatok dto);
        bool IsSuccessAuthorizedDate();
        void SetTantargyFelosztasElfogadas(int intezmenyId, int tanevId, bool elfogadva, string elutasitas_ok);
        void SetTantargyFelosztasVeglegesites(int intezmenyId, int tanevID, bool veglegesit, bool isKovTanev);
        void Update(IIntezmenyAdatok dto);
        IEnumerable<string> GetIntezmenyVarosai(int intezmenyId, int tanevId);
        string GetEnvironmentName(string intezmenyAzonosito, string key);
    }
}
