﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ILepEloadasJegyzekDal
    {
        ILepEloadasJegyzek Get();

        ILepEloadasJegyzek Get(int id);

        void FullUpdate(ILepEloadasJegyzek dto);

        void Update(ILepEloadasJegyzek dto);

        void Insert(ILepEloadasJegyzek dto);

        void Delete(ILepEloadasJegyzek dto);

        DataSet GetEloadasJegyzekek(int tanevId, int eloadasId, int felhasznaloId, bool isMindenEvfolyamJog, DateTime datum, int evFolyamId, string szervezetNev, string eloadasNev, DateTime kezdete, DateTime vege, string eloadasHelyszin);

        DataSet GetTanulokForEloadas(int tanevId, int eloadasId, int evfolyamId, string filter, int? osztfoId = null);

        DataSet GetOsztalyokForEloadas(int tanevId, int eloadasId, int evfolyamId, int? osztfoId = null);

        DataSet GetTanuloEloadasai(int felhasznaloId);

        DataSet GetEloadasJelentkezesEmailData(int id);

        DataSet GetEloadasLemondasEmailData(int id);

        int GetTorlendoTanuloSzam(int intezmenyId, int tanevId, int eloadasId, int osztalyId);

        void DeleteTanulokForEloadasByOsztaly(int intezmenyId, int tanevId, int eloadasId, int osztalyId);

        bool SaveGondviseloEngedelyezes(int intezmenyId, int tanevId, int eloadasId, int tanuloId, int gondviseloId, string dontes);

        DataSet GetTanulokForEloadasWithMegjelent(int eloadasId, DateTime eloadasDatum);

        DataSet GetEloadasokTanuloinakOsszesitoje(int tanevId, List<int> osztalyIdList, int oktNevKategoria);

        DataSet GetJelentkeztetettOsztalyokIdForEloadas(int tanevId, int eloadasId, int? osztalyFonokId = null);

        void DeleteTanulokByEloadasId(int tanevId, int eloadasId);
    }
}
