﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.DataAccessObjects.Mulasztas;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IMulasztasDal
    {
        ITanuloMulasztas Get();
        ITanuloMulasztas Get(int id);
        void Insert(ITanuloMulasztas entity);
        void FullUpdate(ITanuloMulasztas entity);
        void Delete(ITanuloMulasztas entity);
        void Delete(int id);
        DataSet GetHallgatoMulasztasaiDataSet(MulasztasKeresesePCO pco);
        DataSet GetMulasztasDataSet(MulasztasKeresesePCO pco, bool igazoltEsIgazolatlan = false, bool fromSearchPanel = false, int? csoportVezetoId = null);
        DataSet GetMulasztasokDatumNezetDetailGrid(DateTime mulasztasDatuma, int osztalyCsoportId, bool isCsoportVezeto);
        DataSet GetTanuloMulasztasai(int tanuloId);
        DataSet GetOsztalyCsoportTanuloiMulasztasEsFelmentes(int osztcsopId, int tanoraId, int targyId, int tanarId, DateTime date, int csakMegtartott, DateTime tanevElsoTanitasiNapja, DateTime tanevUtolsoTanitasiNapja, int tanevId, int intezmenyId, MulasztasTipusEnum alapertelmezettMulasztasTipus);
        DataSet GetTanuloIgazolatlanMulasztasIdoszakban(int tanuloId, DateTime kezdete, DateTime vege);
        DataSet GetTanuloIgazoltMulasztasIdoszakban(int tanuloId, DateTime kezdete, DateTime vege, int tipus);
        Dictionary<int, bool> GetIsMulasztashozTartozoOsztalyAlapkepzesesByMulasztasIdDictionary(List<int> mulasztasIdFilters);
        DataSet GetParhuzamosOraNaplozottMulasztasTanuloId(DateTime kezdete, DateTime vege, int tanoraId);
        DataSet GetDatumNezetDataByOsztalyCsoportId(int osztalyCsoportId, int intezmenyId, int aktualisTanevId, bool isCsoportVezeto);
        DataSet GetTanulokMulasztasaiKesesei(int intezmenyId, int tanevId, int? osztalyCsoportId = null, int? tanuloId = null, bool isCsoportVezeto = false, int? szervezetTipusId = null);
        DataSet GetTanuloMulasztasaiGrid(MulasztasKeresesePCO pco, bool igazolandok, int? csoportVezetoId, int osztalyCsoportId);
        DataSet GetTanuloMulasztasaiDetailGrid(MulasztasKeresesePCO pco, bool igazolando, int? csoportVezetoId);
        DataSet GetMulasztasokNaploNezetData(int tanevId, int intezmenyId, int osztalyCsoportId, DateTime datum, bool isCsoportVezeto,int? szervezetTipusId = null);
        List<MulasztasPushNotificationDao> GetAllSchemaMulasztasNotification();
        DataSet GetTanuloLegutobbiMulasztasai(int tanuloId);
        void SetMulasztasAsKikuldott(IEnumerable<int> idList);
        bool VaneMarIgazolt(int tipusId, int tanuloId, int oraId);
        DataSet GetTanuloNemUresTantargyiMulasztasaiIdoszakban(int tanuloId, List<int> tantargyIdList, DateTime kezdete, DateTime vege);
        void SetMulasztasTipusUres(int tanuloId, int tantargyId, DateTime kezdete, DateTime vege, int felhasznaloId);
        void BulkSaveMulastas(string json, int modifyId, DateTime modifyDate, int intezmenyId, int tanevId);
        DataSet GetTanuloJelenletDataSet(int tanevId, int tanoraId);
        DataSet GetTanuloMulasztasaiData(int tanevId, int tanuloId, int mulasztastipusa, bool igazolt);
    }
}
