﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface INaptariNapDal
    {
        void Delete(int id);
        void FullUpdate(INaptariNap dto);
        INaptariNap Get();
        INaptariNap Get(int id);
        DateTime? GetDatumElottiUgyanolyanNapDatuma(DateTime date, bool mindenhet);
        DateTime? GetDatumUtaniUgyanolyanNapDatuma(DateTime date, bool mindenhet);
        DataSet GetNaplozottOrakTanarai(int? naptariNapId);
        int? GetNaptariNapId(DateTime datum);
        List<int> GetNaptariNapIdsIntervallumonBelul(DateTime kezd, DateTime veg);
        void Insert(INaptariNap dto);
        bool IsTanitasiNap(DateTime datum, List<int> tanitasiNapIdList, int tanevId);
        void Update(INaptariNap dto);
        void UpdateNaptariNapokForOsszefuggoSzakGyak(DateTime newSzakGyakKezdoDatum, DateTime newSzakGyakVegDatum, int tanevId);
        DataSet GetNaptariNapData(DateTime datum, int tanevId);
        bool GetIsEgyediNapByDate(DateTime datum, int tanevId);
        DataSet GetNapTipusData(int naptipus, int tanevId);
        bool GetIsEgyediNapByDateAndOsztalyCsoportId(DateTime datum, int tanevId, int osztalyCsoportId);
        DataSet GetIsEgyediNapByDateAndOsztalyCsoportNev(DateTime datum, int tanevId, string osztalyCsoportNev);
    }
}
