﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface INebuloDal
    {
        DataSet GetNebuloListForGrid(NebuloSearchPco pco);

        DataSet GetNebuloListForExport(NebuloSearchPco pco);

        void SetFelvetelStatusza(int nebuloId, FelvetelStatuszaTipusEnum felvetelStatusza);

        void SetKozpontiMegjelent(int nebuloId, bool megjelent);

        INebulo Get();

        INebulo Get(int id);

        DataSet GetNebuloListByIdList(List<int> idList);

        DataSet GetNebuloList(int tanevId);

        DataSet GetErtesitendoNebuloList();

        void Insert(INebulo dto);

        void FullUpdate(INebulo dto);

        void Update(INebulo dto);

        void Delete(int id);

        void DeleteKIRStatusz(int id);

        void SaveNebuloMultiEdit(NebuloMultiEditPco parameters);

        void UpdateErtesitesiDatum(int nebuloId);

        bool CheckOktatasiAzonositoUtkozesValidation(int? nebuloId, int? felvetelStatusza, string oktatasiAzonosito);

        void SetBeiratkozasVeglegesites(bool isVeglegesites);

        DataSet GetNebuloOsszletszam();

        DataSet GetFelvettNebuloList(int intezmenyId, int tanevId);

        string GetNebuloKirFeladatellatasiHelySorszama(int nebuloId, int intezmenyId, int tanevId);

        List<int> GetNebuloFromKontener(string kontenerId);

        void SetNebuloKirStatusz(int nebuloId, string kirStatusz, int intezmenyId, int tanevId);

        int GetNebuloIdByOktatasiAzonosito(string tanuloOktatasiAzonosito, DateTime szuletesiDatum);

        int GetNebuloBy4TOktatasiAzonositoNelkul(string tanuloNevElotag, string tanuloCsaladinev, string tanuloUtonev, string anyjaSzuletesiCsaladnev, string anyjaSzuletesiUtonev, string szuletesiHely, DateTime szuletesiIdo);

        bool GetIsEnableEugyHatarozat();

        DataSet GetAllNebuloDataForBai();

        DataSet GetBAIPreCheckUgyszamList();

        void UpdateNebuloStatusz(string eUgyszam, string tanuloOktatasiAzonosito, int statusz);

        void UpdateNebuloStatusz(int nebuloId, string eUgyszam, int statusz);

        DataSet GetGondviseloBelepesByNebuloOktatasiAzonosito(string NebuloOktatasiAzonosito);

        bool GetKretaPreCheck(int tanevId);

        bool IsNebuloLetezikAdottStatuszban(string oktatasiAzonositoSzama, DateTime szuletesiIdo, int statuszId);

        DataSet GetNemSzinkronizaltNebulok(int tanevId);

        int GetOvodasGvCntByNebuloOktAzon(int tanevId, string oktAzon);
    }
}
