﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;
using Kreta.Enums.ManualEnums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface INyomtatvanyokDal
    {
        IDokumentum Get(int id);
        void Delete(IDokumentum dto);
        void FullUpdate(IDokumentum dto);
        void FullUpdate(IIktatottDokumentum dto);
        void FullUpdate(IIktatottDokumentumok dto);
        DataSet GetCsoportByTanev(int tanevId, int intezmenyId, int? felhasznaloId, OktNevelesiKategoriaEnum? kategoria);
        DataSet GetCsoportNaplo(int csoportId, int intemenyId, int tanevId, bool gyakorlatiOrakMegjelenites, bool elmeletiOrakMegjelenites, bool iskolaErdekuSzamit, DateTime datum, (int jelenletAdatokOsszesitese, int jelenletTablazatElrendezese)? jelenletAdatokMegjelenese);
        DataSet GetDokumentumFejlecLablecSablon(int intezmenyId, int? tanevId);
        DataSet GetEgyebFoglalkozasiNaplo(int csoportId, int intemenyId, int tanevId, bool iskolaErdekuSzamit, DateTime datum, bool szoveges = true);
        DataSet GetEgyuttmukodesiMegallapodas(int tanevId);
        DataSet GetElfogadottTantargyfelosztasok(int tanevId, int intezmenyId, bool isElfogadott, bool isKlebersberg);
        DataSet GetErtesitesSzuloknekEsIntezmenyeknek(int osztCsopId, int tanevId, bool iskolaErdekuSzamit, int igazolatlanOrakSzama, bool tankoteles = false, bool gondviselonek = false, bool kiiratkozottTanulokMegjelenitese = false, bool isMuveszetOktatas = false, bool gondviseloIsTorvenyes = false);
        DataSet GetErtesito(int osztalyId, int tanevId, int ertekelesTipus, bool iskolaErdekuSzamit, int tanitasiHetekSzamaVegzos, int tanitasiHetekSzamaNemVegzos, bool altantargyBeszamitasa, int nyomtatvanyNyelvEnum, bool elmeletGyakorlat = false, bool isBizonyitvany = false, bool kozossegiSzolgalat = false, bool isShowTanuloiAtlag = false, bool isMuveszetOktatasi = false, int tanuloId = -1, bool kiiratkozottTanulokMegjelenitese = true, bool negyedevreSzamoltMulasztasok = true);
        DataSet GetFelhasznaloIktatottDokumentumai(IktatottDokumentumSearchPco searchPco);
        DataSet GetFogadooraInfo(int alkalmazottId, int tanevId);
        DataSet GetFoglalkozasByTanev(int tanevId, int intezmenyId, int? felhasznaloId, int? oktNevelesiKategoriaId = 7553);
        DataSet GetFoszamosAlszamosIktatottDokumentumIds(int foszamosIktatottDokumentumId);
        DataSet GetHaladasiMunkafuzet(int tanevId, int? osztalyId, int? tanarId, bool? isCsoport, OktNevelesiKategoriaEnum? feladatKategoria = null, bool? isKapcsolodoCsoportokSzureseOsztalyBesorolasra = null);
        DataSet GetHelyettesitesekListaja(int tanevId, int intezmenyId, DateTime idoszakKezdete, DateTime idoszakVege, int helyettesitesListaFormatumId);
        DataSet GetHelyettesitesiNaplo(int tanarId, int tanevId, int intezmenyId, HelyettesitesiNaploBontasEnum bontas);
        DataSet GetHozzatartozok(int? osztalyId, int intezmenyId, int tanevId);
        DataSet GetIktSzandeknyilatkozatAdatok(int intezmenyId, int tanevId);
        DataSet GetIktSzandeknyilatkozatokGrid(int tanevId, int intezmenyId);
        DataSet GetIntezmenyCimeByTanev(int tanevId);
        int GetIntezmenyiIktatottDokumentum(int intezmenyId, int? tanevId, int dokumentumTipusId);
        DataSet GetIskolalatogatasiIgazolas(int osztalyId, int tanevId, DateTime datum, bool isSzakkepzoIntezmeny, int? felnottkepzesesJogviszonyId);
        DataSet GetKirStatEvfolyam(int tanevId, int feladatellatasiHelyId);
        DataSet GetKirStatFelhasznaloGyogytestneveles(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatFelhasznaloKettosAllampolgar(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatFelhasznaloKonduktiv(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatFelhasznaloNoks(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatFelhasznaloPedagogus(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatFelhasznaloTanoranKivuliCsoport(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatFelhasznaloTerem(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKirStatTanuloEletkor(int tanevId, int feladatellatasiHelyId, bool isKirstat);
        DataSet GetKirStatTanuloLakohely(int tanevId, int feladatellatasiHelyId, bool isKirstat = true);
        DataSet GetKozossegiJelentkezesLap(int intezmenyId, int tanevId, int osztalyId);
        DataSet GetKozossegiSzolgalatNaplo(int intezmenyId, int tanevId, int osztalyId);
        DataSet GetKulcsszoertekekOnIktatottDokumentum(int intezmenyId, int tanevId, int iktatottDokumentumId);
        DataSet GetLezartNaplosOsztalyokDs();
        DataSet GetKeresztfelevesOsztalyIdDs(int tanevId);
        DataSet GetMunkaidoElszamololap(MunkaidoElszamololapPCO pco);
        DataSet GetMuveszetiCsoportByTanev(int tanevId, int felhasznaloId = -1);
        DataSet GetNapkozisCsoportTanuloinakHaviMulasztasiOsszesitoje(int intezmenyId, int tanevId);
        DataSet GetNapkozisNaplo(int csoportId, int intemenyId, int tanevId, bool iskolaErdekuSzamit, DateTime datum, bool szoveges = true);
        DataSet GetNaplobaNemBejegyzettFoglalkozasok(int intezmenyId, int tanevId, int? osztalyId, int? tanarId, DateTime elsoNap, OktNevelesiKategoriaEnum kategoria);
        DataSet GetNebuloErtesito(int intezmenyId, int? tanevId, int nebulo);
        DataSet GetNebuloErtesitoStatusz(int intezmenyId, int tanevId, int statusz);
        DataSet GetNemKotottMunkaidoReszletezo(int alkalmazottId, int tanevId, int intezmenyId, int honapId);
        DataSet GetNyomtatvanyStoredProcedureDataSet(string storedProcedure, Dictionary<string, string> spParameters);
        DataSet GetOrarendOsszes(int intezmenyId, int tanevId, int? pedagogusId, int? teremId, int? osztalyCsoportId, int orarendTipusa, DateTime hetKezdete, DateTime hetVege, bool kapcsolodoCsoportokMegjelenitese, bool osztalyBontasokMegjelenitese, OktNevelesiKategoriaEnum? kategoria);
        DataSet GetOsztalyByTanev(int tanevId, int intezmenyId, int? felhasznaloId, OktNevelesiKategoriaEnum? kategoria);
        DataSet GetOsztalynaplo(int osztalyId, int intezmenyId, int tanevId, int? aktivTanevId, bool iskolaErdekuSzamit, bool fuggolegesTantargyak, bool isReszletesMulasztasok, bool isEgyebFoglalkozasok, int minTanoraSzam, bool isEllenorzo, DateTime orarendErvenyessegiDatum, bool isSzovegesNaplo = false, int tanuloId = 0, bool osztalyTanuloOrarendbenNemLatszik = false);
        DataSet GetOsztalyokEvesOraszama(int tanevId, int tanitasiHetekSzamaVegzos, int tanitasiHetekSzamaNemVegzos, bool altantargyBeszamitasa, OktNevelesiKategoriaEnum? oktNevelesiKategoriaId);
        DataSet GetOsztalyokHaviHianyzasiOsszesitoje(int intezmenyId, int tanevId);
        DataSet GetPedagogusAltalAdottOsztalyzatok(int tanarId, int tanevId, int intezmenyId, bool ertekelesmodSuly, OktNevelesiKategoriaEnum? kategoria);
        DataSet GetPedagogusByTanev(int tanevId, int intezmenyId, int? felhasznaloId = null, bool oktatasiAzonositoval = false, bool csakSzakOktatasertFelelosok = false, OktNevelesiKategoriaEnum? oktNevKategoria = null);
        DataSet GetStatPedagogusTanuloinakTantargyiMulasztasaiMegtartott(int tanevId, int tanarId);
        DataSet GetSzakmaiGyNaplo(int csoportId, int intemenyId, int tanevId, bool iskolaErdekuSzamit, DateTime datum, bool szoveges = true);
        DataSet GetTanarOrarendiLefedettseg(int intezmenyId, int tanevId);
        DataSet GetTanevKozbenKilepettTanulok(int tanevId);
        DataSet GetTantargyaElmaradtOrainakSzama(int tanevId, int intezmenyId);
        DataSet GetTantargyakMegtartottOrainakSzama(int intezmenyId, int tanevId);
        DataSet GetTanuloErtesito(int osztalyId, int tanevId, int tanuloId, int ertekelesTipus, bool iskolaErdekuSzamit, bool elmeletGyakorlat = false, bool isBizonyitvany = false, bool kozossegiSzolgalat = false);
        DataSet GetTanuloiAdatlap(int osztCsopId, int tanevId, DateTime datum);
        DataSet GetTanuloJelenletiIvAlkalmankent(int foglalkozasId, int tanevId, DateTime kivalasztottNap);
        DataSet GetTanulokBejegyzesStatisztika(int osztalyId, int tanevId);
        DataSet GetTanulokByOsztaly(int osztalyId);
        DataSet GetTanulokFeljegyzesekReszletezese(int osztalyId, int tanevId);
        DataSet GetTanulokFelmentesekHatarozatok(int osztalyId, int tanevId);
        DataSet GetTanulokGyorsBejegyzesStatisztika(int osztalyId, int tanevId);
        DataSet GetTanulokJegyeiReszletezes(int osztCsopId, int tanevId);
        DataSet GetTanulokMulasztasokKesesek(int osztalyId, int intezmenyId, int tanevId, bool elmeletGyakorlat);
        DataSet GetTanulokMulasztasokReszletezese(int osztalyId, int tanevId, bool iskolaErdekuSzamit);
        DataSet GetTanulokTantargyMulasztasokReszletezese(int osztalyId, int tanevId, bool iskolaErdekuSzamit);
        DataSet GetTanuloOrarend(int tanevId, int osztalyId, int aktivtanevId, bool isEgyebFoglalkozasok, DateTime orarendErvenyessegiDatum, int tanuloId = 0);
        DataSet GetTanuloszerzodes(int intezmenyId, int tanevId, string tanuloId, int osztalyId);
        DataSet GetTeremByTanev(int tanevId, int intezmenyId);
        DataSet GetTorzslapAdatok(int osztalyId, int tanevId, bool iskolaErdekuSzamit, int nyomtatvanyNyelvEnum, bool isKozossegiSzolgalat, int tanitasiHetekSzamaVegzos, int tanitasiHetekSzamaNemVegzos, bool altantargyBeszamitasa, bool isMuveszetOktatasi, int idegenNyelvId = 534, bool is20_21OrLaterTanev = false);

        DataSet GetTorzslapEsBizonyitvanyAdatok(int tanevId, int osztalyId, int nemzetisegiNyelvId, bool iskolaErdekuSzamit, bool isKozossegiSzolgalat, int tanitasiHetekSzamaVegzos, int tanitasiHetekSzamaNemVegzos, bool altantargyBeszamitasa, bool isMuveszetOktatasi, bool is20_21OrLaterTanev, int nyomtatvanyNyelvEnum = 0, bool isShowTanulmanyiAtlag = false, bool kiiratkozottTanulokMegjelenitese = true, bool kellAtsorolasiZaradek = true);

        DataSet GetUzenofuzetErtekelolap(int osztalyId, int tanevId, int intezmenyId);
        int? IktatasLetezik(int intezmenyId, int? tanevId, int dokumentumKategoria, int dokumentumTipus, int elemiSzint, int? osztalyId = null, int? csoportId = null, int? tanarId = null, int? evfolyamId = null, int? teremId = null, string gondviseloNeve = null, string tanuloNeve = null, string tanuloEgyediAzon = null, string alkalmazottEgyediAzon = null);
        int Insert(IDokumentum dto);
        int Insert(IDokumentumKulcsszo dto);
        int Insert(IDokumentumKulcsszoErtek entity);
        int Insert(IIktatottDokumentum dto);
        void Insert(IIktatottDokumentumok entity, IFelhasznalo iktato, IFelhasznalo dokumentumPartner);
        bool IsCsoportVagyOsztalyByTanev(int tanevId, int intezmenyId, int osztalyCsoportId);
        void Update(IIktatottDokumentum dto);
        IDokumentumKulcsszo GetDokumentumKulcsszo();
        IDokumentumKulcsszoErtek GetDokumentumKulcsszoErtek();
        void AddDokumentumKulcsszo(IIktatottDokumentum dokumentum, IDokumentumKulcsszo kulcsszo);
        DataSet GetKapcsolodoOsztalyCsoportokByTanarId(int tanarId, int tanevId, bool osztalyKell, bool csoportKell, bool tartottOraKell, OktNevelesiKategoriaEnum? feladatKategoria, string osztalyGroupName = null, string csoportGroupName = null);
        DataSet GetKapcsolodoOsztalyCsoportokByTanarId(int tanarId, int tanevId, bool osztalyKell, bool csoportKell, bool tartottOraKell, MuveszetiAgEnum? muveszetiAg, string osztalyGroupName = null, string csoportGroupName = null);
        DataSet GetIntezmenyiMulasztasiOsszesitoje(int tanevId);
        DataSet GetIntezmenyiTanulokNevsoraOsszesitoje(int tanevId);
        DataSet GetPedagogusIgazolas(int tanevId, int alkalmazottId);
        DataSet GetJogviszonyTipusTanterviJellegByTanulocsoportIdList(List<int> tanulocsoportIdList);
        DataSet GetJogviszonyTipusTanterviJellegByOsztalyIdList(List<int> osztalyIdList, int tanevId, DateTime datum);
        DataSet GetBesorolasDetailsByTanulocsoportIdList(List<int> tanulocsoportIdList);
        DataSet GetTanulocsoportIdListByOsztalyIdList(List<int> osztalyIdList);
        DataSet GetEbedNormativaRiport(int tanevId, int oraszam, DateTime tanevElsonapja, DateTime tanevUtolsoNapja, bool isAmiHianyzasIsMegjelenjen);
        DataSet GetAmiTorzslapAdatok(int tanevId, int osztalyId, bool iskolaErdekuSzamit);
    }
}
