﻿using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IOraSorszamozasHalmazDAL
    {
        bool NevExists(int tanevId, string nev, int id);

        bool OsszerendelesExists(int tanevId, int osztalyCsoportId, int tantargyId, int halmazId, List<int> deletedOsszerendeslIds);

        IOraSorszamozasHalmaz Get(int id);

        DataSet GetAllPaged(int tanevId, OraSorszamozasHalmazSearchPCO pco);

        DataSet GetOsszerendelesek(int halmazId, bool forDetail = false);

        void Delete(int id, int intezmenyId, int tanevId);

        void DeleteOsszerendeles(int osszerendelesId, int intezmenyId, int tanevId, bool updateTanoraEvesSorszam = true);

        int Save(int tanevId, int id, string nev, bool kozosOraSorszamozasElteroTanarnal, int tipus, int? kezdoertek);

        int SaveOsszerendeles(int tanevId, int osztalyCsoportId, int tantargyId, int halmazId);

        void DeleteOsszerendelesek(int halmazId, IEnumerable<int> idsInGrid, int intezmenyId, int tanevId);

        void SetHalmazOsszerendeles(int halmazId, int osszerendelesId);

        List<int> GetEvesOraszamForTantargyAndOsztaly(int tanevId, int itezmenyId, int osztalyCsoportId, int tantargyId);
    }
}
