﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IOsztalyCsoportDal
    {
        int? GetCsoportTipusByOsztalyCsoportId(int osztalyCsoportId, int intezmenyId);
        bool GetIsCsoport(int osztalyCsoportId);
        bool GetIsCsoportTipusAlapjan(int osztalyCsoportId, int csoportTipusId);
        bool GetIsOsztaly(int osztalyCsoportId);
        bool GetIsOsztalyCsoportBontott(int osztalyCsoportId);
        bool GetIsVegzosOsztalyCsoport(int osztalyCsoportId);
        DataSet GetOsztalyCsoportDataSet(int tanevId, int? oktNevelesiKategoriaId = null);
        List<IOsztalyCsoport> GetOsztalybontasosCsoportok(int osztalyId, int tanevId);
        DataSet GetOsztalyCsoportFoglalkozasAlapjan(int foglalkozasId);
        DataSet GetOsztalyCSoportok(string osztaly, string csoport, int evfolyamTipus = -1, bool isOsztalyCsoportIsKell = true);
        DataSet GetOsztalyCsoportokDataSet(string commandText, Dictionary<string, object> commandParameterList);
        DataSet GetOsztalyCSoportokEvfolyamAlapjan(string osztaly, string csoport, int evfolyamTipus = -1);
        DataSet GetOsztalyCsoportListByEvfolyam(int intezmenyId, int tanevId, string osztaly, string csoport, int evfolyamTipus = -1, int? tanarId = null, bool isOsszefuggoSzakGyak = false, int? feladatKategoriaId = null, bool? csakOsztalyEsTanoraJelleguCsoport = null, bool? isDualisKepzes = null, int? szervezetId = null, int? szervezetAdatokHalmaza = null);
        DataSet GetCsoportListByCsoportVezeto(int tanevId, int tanarId, bool isTanoraiCeluCsoportok, int tanoraiCsoportTipusId, bool isSzuperOsztalyfonok, bool? szervezetTipusId = null, int? szervezetId = null);
        DataSet GetCsoportBesorolasModositasValidacio(int tanevId, int csoportId, int tanuloId, DateTime datumTol, DateTime datumIg, OktNevelesiKategoriaEnum? feladatKategoria, bool isTorolhetosegVizsgalat);
        DataSet GetOsztalyCsoportokEvfolyamAndTanevAlapjan(int tanevId, string osztaly, string csoport, int evfolyamTipus = -1);
        DataSet GetOsztalyCsoportokGrouped(int? feladatKategoriaId);
        DataSet GetOsztalyCsoportokGroupedByFoglalkozas(int userId);
        DataSet GetFelhasznaloOsztalyaiByFoglalkozasAndOsztfo(int intezmenyId, int tanevId, int userId, string osztalyGroupName, string csoportGroupName, bool isKellCsoportvezeto = false);
        DataSet GetVezetettOsztalyCsoportokByAlkalmazott(int tanevId, int alkalmazottId);
        DataSet GetOsztalyCsoportokForFeljegyzesek(int userId);
        DataSet GetOsztalyCsoportokGroupedByKapcsolodas(int userId);
        DataSet GetOsztalyCsoportokTanoranKivuliFoglalkozasokhozWithGroup(bool csakOsztalyEsTanoraJelleguCsoport, int tanevId);
        DataSet GetOsztalyCsoportokWithTanev(int tanevId);
        DataSet GetOsztalyokOsztalyfonokAlapjan(int osztalyfonokVagyHelyettesId);
        DataSet GetKapcsolodoOsztalyCsoportokByTanarId(int tanarId, bool osztalyKell, bool csoportKell, bool tartottOraKell, OktNevelesiKategoriaEnum? feladatKategoria, string osztalyGroupName = null, string csoportGroupName = null);
        DataSet GetOsztalyokOsztalyfonokAlapjan(int osztalyfonokVagyHelyettesId, int intezmenyId, int tanevId);
        DataSet GetOsztalyCsoportok(int tanevId, int? feladatKategoriaId, bool isAktiv = false, bool isFromSzervezet = false, List<int> osztalyfonokIds = null, List<int> tanuloIds = null, int? oktatasiNevelesiFeladatId = null);
        DataSet GetCsoportokMindenAdataForExport(int tanevId, OktNevelesiKategoriaEnum? feladatKategoria, CsoportSearchPco pco, bool isSelectedTanev21_22OrLater, bool isSzakkepzoIntezmeny, DateTime? aktualisTanevElsoTanitasiNapja = null);
        DataSet GetEvfolyamAktualisLetszamadataiExcelExport(int tanevId, OktNevelesiKategoriaEnum feladatKategoria, OsztalySearchPco pco, DateTime aktualisTanevElsoTanitasiNapja);
        DataSet GetOsztalyokMindenAdataExcelExport(int tanevId, OktNevelesiKategoriaEnum feladatKategoria, OsztalySearchPco pco, DateTime aktualisTanevElsoTanitasiNapja, bool isSelectedTanev21_22OrLater, bool isSzakkepzoIntezmeny);
        DataSet GetOsztalybaJaroTanulokExcelExport(int tanevId, OsztalySearchPco pco, DateTime? aktualisTanevElsoTanitasiNapja = null);
        DataSet GetCsoportbaJaroTanulokExcelExport(int tanevId, OktNevelesiKategoriaEnum? feladatKategoria, CsoportSearchPco pco, DateTime? tanevElsoTanitasiNapja = null);
        bool IsOsztaly(int osztcsopId, int tanevId);
        List<int> GetTanuloOsztalyCsoportjaiIdList(int tanuloId, DateTime? datum = null);
        List<IOsztalyCsoport> GetTanuloOsztalyCsoportjai(int tanuloId, DateTime? datum = null);
        List<int> GetTanuloMindenkoriOsztalyCsoportjai(int tanuloId);
        bool IsTanuloOsztalyCsoportTagja(int tanuloId, int osztalyCsoportId, DateTime? datum = null);
        bool IsOsztalyCsoportNemTanoraiCeluCsoport(int osztalyCsoportId);
        IOsztalyCsoport GetSpecific(string condition, Dictionary<string, object> commandParameterList = null);
        IOsztalyCsoport Get(int id);
        IOsztalyCsoport Get();
        DataSet GetCsoportokCsoportvezetoAlapjan(int userId, bool showTanoraCeluCsoportok);
        int? GetOsztalyfonokElsonekMegtalaltOsztalya(int tanarId);
        DataSet GetOsztalyCsoportokOktatasNevelesiFeladatTipus(string osztalyIdString);
        DataSet GetTanuloBesorolasData(int intezmenyId, int tanevId, int tanuloId, int osztalyCsoportId);

        DataSet GetTanuloBesorolasaiKisorolasaiDatumDataByTanuloIdList(List<int> tanuloIdList, int osztalyCsoportId);

        bool HasTanitasiOra(int osztalyCsoportId);
        bool HasTanuloBesorolas(int osztalyCsoportId, bool checkOsztalybontottCsoportok = false);

        DataSet GetExistsHianyzasErtekelesFeljegyzesSorolaskor(List<int> pTanuloIdList, DateTime pSorolasDatum, int? pOsztalyCsoportId = null, bool pHianyzasKovetes = false, bool pErtekelesKovetes = false, bool pFeljegyzesKovetes = false);
        int GetOsztalyCsoportFeladatKategoria(int osztalyCsoportId);
        int GetOsztalyCsoportOktatasNevelesiFeladatTipus(int osztalyCsoportId);
        DataSet GetOsztalyTanuloinakGondviseloi(int tanevId, int osztalyId, DateTime datum);
        DataSet GetOsztalyokByMuveszetiAg(MuveszetiAgEnum muveszetiAg, int tanevId);
        DataSet GetOsztalyCsoportokFeladatKategoria(string osztalyIdString);
        DataSet GetOsztalybontasosCsoportokOsztalyAdatokkal(string csoportIdString, int tanevId);
        DataSet GetAutoEgyeniCsoportok(string csoportIDArrayString, int tanevId);

        List<int> GetKapcsolodoOsztalyBontasokkal(int osztalyCsoportId);

        DataSet GetTanuloOsztalyDataSetByOsztalyCsoportId(int tanevId, int osztalyCsoportId);

        DataSet GetKapcsolodoOsztalyCsoportok(int osztalyCsoportId);

        DataSet GetOsztalyCsoportNev(string osztalyCsoportNev, int? id, int tanevId);
        DataSet GetOsztalyBesorolasModositasValidacio(int tanevId, int fromOsztalyId, int toOsztalyId, int tanuloId, DateTime datumTol, DateTime datumIg, OktNevelesiKategoriaEnum feladatKategoria, bool isTorolhetosegVizsgalat, bool isCheckMaxOsztalyReturnKilepes);
        DataSet GetTanuloOsztalyEsFeladatkategoriaList(int tanuloId, int tanevId, int intezmenyId, DateTime? datum = null);
        DateTime? GetVegzosUtolsoNapByOsztalycsoportId(string azonosito, int tanevId, int intezmenyId, int osztalycsoportId);
        DataSet GetCsoportTanuloinakSzakmajegyzeke(int tanevId, int csoportId, DateTime datum);
        DataSet GetTanulokSzakmajegyzeke(int tanevId, List<int> tanuloIds, DateTime datum);
        DataSet GetOsztalyCsoportAdatokDataSet();
    }
}
