﻿using System;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface IOsztalyDal
    {
        void Delete(IOsztaly dto, int intezmenyId, int tanevId, bool updateTanoraEvesSorszam = true);
        void FullUpdate(IOsztaly dto);
        IOsztaly GetSpecific(string condition, int tanevId);
        IOsztaly Get();
        IOsztaly Get(int id);
        DataSet GetOnlyOsztalyokForDDL(int tanevId, int? tanarId = default(int?), OktNevelesiKategoriaEnum? feladatKategoria = null, bool forSzirStatTanulo = false);
        DataSet GetOsztalyCsoportjai(int osztalyId, OktNevelesiKategoriaEnum kategoria);
        int GetOsztalyfonokByOsztalyId(int osztalyId);
        DataSet GetOsztalyokByTanevForDDL(int tanevId, int? feladatKategoriaId = null);
        DataSet GetOsztalyokForDDL(bool kellTanev = false, int? tanarId = default(int?));
        void Insert(IOsztaly dto);
        DataSet OsztalyExport(OsztalySearchPco pco, int tanevId, DateTime? aktualisTanevElsoTanitasiNapja = null);
        DataSet OsztalyKereses(OsztalySearchPco pco, int? tanevId);
        void UpdateOsztalyTanuloiSzakkepzesesAdatok(int osztalyId, SzakkepzesesAdatokPCO szakkepzesesAdatok);
        DataSet GetOsztalyNKTesSZKTSzakkepzesesAdatok(int osztalyId);
        DataSet GetOsztalyDataSet(int tanevId, int? oktNevelesiKategoriaId = null);
        DataSet GetOsztalyokForDDL(int? tanevId, int? tanarId = null, bool? szuperOsztalyfonok = null, OktNevelesiKategoriaEnum? feladatKategoria = null);
        DataSet GetOsztalyokCsoportokForDDL(int? tanevId, int? tanarId = null, bool? szuperOsztalyfonok = false, OktNevelesiKategoriaEnum? feladatKategoria = null);
        DataSet GetOsztalySzakkepzoAdatok(int osztalyId);
        DataSet GetOsztalyEsBontottCsoportjai(int osztalyId);
        DataSet GetOsztalyTanuloinakKepzesiJellemzoi(int tanevId, int itezmenyId, int osztalyId, int jegyzekTipus, bool isAktivTanev);
        DataSet GetOsztalyTanuloiByKepzesiJellemzok(TanuloKepzesiJellemzoPco pco, int tanevId, int intezmenyId, bool isAktivTanev);
        DataSet GetOsztalyTanuloiByMunkarend(int osztalycsoportId, bool hasMunkarend, bool isAktivTanev);
        DataSet GetOsztalyTanuloinakSzamaKepzesiJellemzokSzerint(int osztalyId, int tanevId, int intezmenyId, bool isAktivTanev);
        DataSet GetOsztalyMunkarendSzama(int osztalyId, bool isAktivTanev);
        void UpdateOsztalyTanuloiReszszakepzesAdatokToNull(int osztalyId, int tanevId, int intezmenyId, int felhasznaloId);
        void UpdateOsztalySZMKKepviseloIdToNull(int osztalyId, int tanevId, int intezmenyId);
        void UpdateOsztalySZMKKepviseloHelyettesIdToNull(int osztalyId, int tanevId, int intezmenyId);
    }
}
