﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ISzamonkeresElorejelzesDal
    {
        void SetBejelentettSzamonkeresAsKikuldott(IEnumerable<int> idList);
        void Delete(int id);
        void DeleteAllByOrarendiOraGroupId(int tanevId, int orarendiOraGroupId);
        DataSet GetSzamonkeresForOrarendiOraGroupId(int tanevId, int? orarendiOraGroupId);
        void DeleteAllByOraGroupIdAndIdoszak(int tanevId, int orarendiOraGroupId, DateTime? oraErvenyessegKezdete, DateTime? oraErvenyessegVege, bool idoszakonKivul = false);
        void FullUpdate(ISzamonkeresElorejelzes dto);
        ISzamonkeresElorejelzes Get();
        ISzamonkeresElorejelzes Get(int id);
        DataSet GetBejelentettSzamonkeresekByDateRange(int intezmenyId, int tanevId, DateTime start, DateTime end);
        DataSet GetBejelentettSzamonkeresekGrid(int intezmenyId, int tanevId, SzamonkeresElorejelzesSearchPco pco, OktNevelesiKategoriaEnum? feladatKategoria);
        DataSet GetSzamonkeresElorejelzesDetailDataSet(int intezmenyId, int tanevId, SzamonkeresElorejelzesSearchPco pco, bool isKellKapcsolodoOsztalyok);
        DataSet GetTanulokSzamonkeresElorejelzesei(int intezmenyId, int tanevId, SzamonkeresElorejelzesSearchPco pco);
        List<(int TanuloId, Guid IdpUniqueId, int SzamonkeresId, int TanevId, int SzamonkeresModId, string TanuloNeve, string TantargyNeve, string IntezmenyAzonosito)> GetAllSchemaBejelentettSzamonkeresNotification();
        bool HasSzamonkeresForOrarendiOraGroupId(int tanevId, int orarendiOraGroupId);
        bool HasSzamonkeresByIdoszak(int tanevId, int orarendiOraGroupId, DateTime oraErvenyessegKezdete, DateTime oraErvenyessegVege, bool idoszakonKivul = true);
        void Insert(ISzamonkeresElorejelzes dto);
        void Update(ISzamonkeresElorejelzes dto);
    }
}
