﻿using System;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITanarDal
    {
        void FullUpdate(IAlkalmazott alkalmazott, IMunkaugyiAdatok adatok);
        void FullUpdate(IPedagogusEletpalyamodell entity);
        void UpdateAlkalmazottEletpalyaModell(IPedagogusEletpalyamodell dto);
        DataSet GetAlkalmazottNames(int tanevId, int intezmenyId, bool oktatasiAzonositoval = false, bool isFromSzervezet = false, int? szervezetId = null, int? szervezetekHalmaza = null);
        DataSet GetBukasokSzama(int tanevId, int tanarId, int darab, double bukasAtlag);
        DataSet GetHeldSubject(int teacherId);
        string GetKepesites(int vegzettsegId, int tanevId);
        DataSet GetKiirtHelyettesitesek(int intezmenyId, int tanevId, int tanarId, int darab);
        DataSet GetKKMainGridVegzettseg(int tanarId);
        DataSet GetMulasztasokSzama(int tanevId, int tanarId, bool isSzuperOsztalyFonok, int darab);
        DataSet GetOsztalyfonokOsztalyfonokhelyettesForDDL(int tanevId, int intezmenyId);
        DataSet GetPedagogusEletpalyamodell(int tanarId);
        DataSet GetPedagogusokOktatasiAzonositoja(int intezmenyId, int tanevId, bool torolt = false);
        int GetSzerepkorId(int jog, int tanevId);
        string GetTanarNev(int id);
        DataSet GetTanarokByTanitottOsztalyForDDL(int osztalyId, int tanevId, bool oktatasiAzonositoval = false);
        DataSet GetTanarokForDDL(bool oktatasiAzonositoval = false, int? tanevId = null, bool isForMentor = false, bool isCsoportnelkuli = false, int? aktualisCsoportvezetoId = null);
        DataSet GetTanulotTanitoTanarok(int tanuloId);
        DataSet GetProfil(int tanarId, int tanevId, Guid? userIdpUniqueId = null);
        DataSet GetTeacherAddressData(int teacherId);
        DataSet GetTeacherEmails(int teacherId);
        DataSet GetTeacherNames(int? kiveveTanarId = null, bool oktatasiAzonositoval = false, int? tanevId = null, bool csakNaploJogkorrel = false);
        DataSet GetTeacherNonStudents(int tanarId, int intezmenyId, int? tanevId, int? osztalyCsoportID);
        DataSet GetTeacherPhones(int teacherId);
        DataSet GetTeacherRating(int teacherId);
        DataSet GetTeacherRoutines(int teacherId);
        DataSet GetTeacherStudents(int tanarId, int tanevId, int? foglalkozasId, int? foglalkozasTipus, double bukasAtlag, bool csakBukasraAllok, int? feladatKategoriaId);
        DataSet GetTeacherSyllabus(int teacherId);
        DataSet GetTimeTableSubjects(int teacherId);
        DataSet GetUtolsoBeNemIrtOrak(int intezmenyId, int tanevId, int tanarId, int darab);
        DataSet GetVegzettseg(int tanarId, int tanevId);
        void Insert(IPedagogusEletpalyamodell entity);
        DataSet KIRTanarokImport(string tanariAdatokXml, int feladatellatasiHelyId, int intezmenyId, int tanevId, int userId);
        DataSet GetTanarokByOktNevKategoria(int tanevId, OktNevelesiKategoriaEnum? oktNevKategoria, int? felhasznaloId = null);
        DataSet GetAlkalmazottNameBirthdays(int tanevId, bool isDualisKepzohelyiOktatok = false);
        int GetTanarId(DateTime datum, int? oraszam, int osztalyCsoportId, int tantargyId);
    }
}
