﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITanevRendjeDal
    {
        ITanevRendje Get();
        ITanevRendje Get(int id);
        void Delete(ITanevRendje entity);
        void RemoveKapcsolodoOsztalyCsoportok(ITanevRendje entity);
        void DeleteEgyediNap(int tanevRendjeId, bool isKezzelRogzitesTorles, int modifierId);
        void DeleteEgyediNapOsztalycsoport(int tanevRendjeId, int osztalycsoportId, int modifierId);
        void DeleteTanevRendjeNewBontottCsoport(int osztalyId, int bonottCsoportId, int modifierId);
        DataSet EnabledNemKotottMunkaidoRogzitese(DateTime date, int intezmenyId, int tanevId);
        void FullUpdate(ITanevRendje entity, bool csoportos, Dictionary<int, bool> osztalyCsoportDic, int tanevId, int modifierId, bool egyediNapKihagyas = false);
        DateTime GetElsoFelevVege(int intezmenyId, int tanevId);
        DateTime GetElsoTanitasiNapDate(int intezmenyId, int tanevId);
        bool GetKezzelrogzitettOrarendiOra(DateTime datum);
        List<int> GetMarFelvettKiemeltTanevEsemenyTipusok(int tanevId);
        DataSet GetOsztalycsoportTanevrendje(DateTime? date, int osztalyCsoportId, int intezmenyId, int tanevId, bool? osszesCsoportVonatkozokat = null);
        DataSet GetTanevHetirendTipusok(int tanevId);
        DataSet GetTanevredhezTartozoOsztCsopList(int tanevId, int tanevrendId, int? feladatKategoriaId, int? mukodesiHelyId, int? feladatEllatasiHelyId);
        string GetTanevrendCsengetesiRendValue(int? id, int tanevId);
        DataSet GetTanevRendjeOsztalyCsoportok(int tanevId, List<int> tanevrendIds);
        int GetTanevrendDefaultCsengetesiRend(int tanevId);
        DataSet GetTanevrendekByCsengetesiRend(int tanevId, int csRendId);
        DataSet GetTanevRendjeByDatum(DateTime datum, int tanevId, int intezmenyId);
        DataSet GetTanevRendjeData(int tanevId);
        DateTime GetUtolsoTanitasiNapDate(int intezmenyId, int tanevId);
        DateTime? GetNapDate(int intezmenyId, int tanevId, NapTipusEnum napEnum, bool returnDefaultValue = true);
        bool GetVanTanevRendjeEsemenyCsengetesiRenddel(DateTime datum, List<int> osztalyIdLista);
        bool GetVanTanevRendjeEsemenyNemKotottMunkaido(int tanevId, DateTime startDatum, DateTime endDatum);
        DateTime? GetVegzosUtolsoTanitasiNap(int tanevId);
        int Insert(ITanevRendje entity, bool csoportos, Dictionary<int, bool> osztalyCsoportDic, int tanevId, int modifierId);
        void InsertEgyediNap(int tanevRendjeId, int intezmenyId, int tanevId);
        void InsertEgyediNapOsztalycsoport(int tanevRendjeId, int osztalycsoportId, int intezmenyId, int tanevId);
        void InsertTanevRendjeNewBontottCsoport(int osztalyId, int bontottCsoportId);
        bool IsDateHasGlobalTanevRend(DateTime date, int tanevId);
        bool IsTanoraOrNapirendRogzitheto(int naptipusId, int intezmenyId, int tanevId);
        DataSet ListTanevRendekOsztalyCsoportokkal(int tanevId, DateTime? start, DateTime? end, int? tanuloId = null, OktNevelesiKategoriaEnum? feladatKategoria = null);
        void GenerateOrarend(int intezmenyId, int tanevId, int? csoportId, DateTime? datum, int? napTipus);
        bool HasTanitasiNap(DateTime date, List<int> tanitasiNapIdList, int tanevId);
        DataSet GetTanevRendjeNaptipusTulajdonsagokkal(int tanevId, int? osztalyCsoportId = null);
        bool IsRendkivuliTanitasiNap(int tanevId, DateTime datum);
    }
}
