﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITanitasiOraDal
    {
        void Delete(int id);
        void Delete(ITanitasiOra dto);
        void FullUpdate(ITanitasiOra dto);
        ITanitasiOra Get();
        ITanitasiOra Get(int id);
        DataSet GetAdminRogzitendoKozpontiOrak();
        DataSet GetAdminTorlendoKozpontiOrakForDate(DateTime start, DateTime end, int hanyadikora);
        DataSet GetElmaradtTanorakForExport(int tanevId, string schema, TanoraKeresesePCO pco);
        DataSet GetHelyettesitettTanorakForExport(int tanevId, string schema, TanoraKeresesePCO pco);
        DataSet GetMegtartottOraByDatumAndOsztalyFonok(DateTime datum, int ofoId);
        DataSet GetMegtartottTanorakForExport(int tanevId, string schema, TanoraKeresesePCO pco, bool isShowId = false);
        int GetOrarendiOraByTanoraGroupId(int groupId, DateTime date);
        DataSet GetOsztalyCsoportMegtartottOrai(int ID, int? tanevId, int intezmenyId);
        int GetTanoraByOrarendiOraGroupId(int groupId, DateTime date);
        DataSet GetTanorakDataSet(TanoraKeresesePCO pco, int? tanevId, int intezmenyId);
        DataSet GetTanorakForTanarHaladasiNaplo(HaladasiNaploTanoraKeresesePCO pco, int? tanevId, int intezmenyId);
        DataSet GetTantargyMegtartottTanorai(int tantargyID, int tanevId);
        DataSet GetTanuloFeljegyzesek(int tanoraId);
        DataSet GetTanuloMulasztasok(int tanoraId);
        DataSet getTanuloTanorai(int felhasznaloId);
        DataSet GetTanulasiEgysegDataSet(int tanevId);
        void Insert(ITanitasiOra dto);
        bool TanitasiOraTeremUtkozesEllenorzes(int intezmenyId, int tanitasiOraID, int orarendiOraID, int teremID, int hetNapja, int hetirend, DateTime oraKezdete, DateTime oraVege);
        void Update(ITanitasiOra dto);
        void UpdateOrarendiOraGroupIds(int oOraId, int? oOraGroupId, DateTime newErvenyessegKezdete, DateTime newErvenyessegVege, DateTime modositasDatuma, int tipus, int modifier);
        DataSet GetTanitasiOraTulajdonsag(int tanitasiOraId, int tanevId);
        void SaveOrUpdateTanitasiOraTulajdonsag(Dictionary<int, bool> oraTulajdonsagok, int tanitasiOraId, int intezmenyId, int tanevId);
        void SaveTanitasiOraDigTamEszkozList(List<int> digTamEszkozList, int tanitasiOraId, int intezmenyId, int tanevId, int felhasznaloId);
        bool HasTanitasiOraTulajdonsag(int tanitasiOraId, int intezmenyId, int tanevId);
        DataSet GetTanorakGridForNaplozasDataSet(int osztalyCsoportId, int tantargyId, int tanevId);
        DateTime GetTanitasiOraLegutobbiModositasa(int tanitasiOraId);
        void UpdateTanitasiOraEvesSorszamTeljesTanev(int intezmenyId, int tanevId);
        void UpdateTanitasiOraEvesSorszamTanitasiOra(int intezmenyId, int tanevId, int tanitasiOraId);
        DataSet ListTanitasiOraKezdeteVege(IEnumerable<int> tanitasiOraIdList);
        DataSet GetDigitalisInformaciokByTanoraIds(IEnumerable<int> tanitasiOraIdList, int tanevId);
    }
}
