﻿using System;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITanmenetDal
    {
        void Delete(int id);
        void DeleteTanmenet(int tantargyId, int osztalyCsoportId, int userId);
        void FullUpdate(ITanmenet dto);
        ITanmenet Get();
        ITanmenet Get(int id);
        DataSet GetOsztalyCsoportTanmenetei(int osztalyCsoportId, int tanevId, OktNevelesiKategoriaEnum? kategoria);
        DataSet GetTanmenetek(TanmenetKeresesePCO pco);
        DataSet GetTanmenetek(int tantargyId, int osztalyId, int? userId = null, int? foglalkozasId = null, Guid? userIdpUniqueId = null);
        int? GetTanmenetIdBySorszamEsFoglalkozas(int evesOraSorszam, int foglalkozasId);
        DataSet GetTantargyTanmenetei(int tantargyId, int tanevId);
        string GetTemaEvesOraSorszamhoz(int tantargyId, int osztalyCsoportId, int feltoltoId, int oraEvesSorszama = 0, string elozoTema = null);
        DataSet GetTemakByTargyEsOsztCsop(int tantargyId = -1, int osztalyCsoportId = -1, int tanarID = -1);
        void Insert(ITanmenet dto);
        void Update(ITanmenet dto);
        DataSet GetTanmenetDataSet(int tanevId, int? alkalmazottId = null, int? oktNevelesiKategoriaId = null);
    }
}
