﻿using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITantargyDal
    {
        void Delete(ITantargy tantargy, int intezmenyId, int tanevId, bool updateTanoraEvesSorszam = true);
        void FollowUpTantargy(int intezmenyId, int aktTanevId, int kovetkezoTanevId, int tantargyId = 0);
        void FollowUpTantargyNyelv(int intezmenyId, int aktTanevId, int kovetkezoTanevId, int tantargyNyelvId);
        void FullUpdate(ITantargy tantargy);
        void FullUpdateNyelv(ITantargyNyelv tantargyNyelv);
        DataSet GetExportTantargyakMindenAdataExcelExport(int tanevId, string tantargyNev, int? tantargyKategoriaId, int? eslTargykategoriaTipusId, int? isErtekelesKorlatozva, int? isFotargy, int? fotargyId, int? isGyakorlati, string rovidNev, string bizonyitvanyNev, int? isAltantargykentBizonyitvanyban, int? isNincsBeloleOra, int? isOsztalyNaplobanNemJelenikMeg, int? isOsztalyokOrarendjebenMegjelenik, int? isTanulmanyiAtlagbaSzamit, int? isAmiTantargy, int? isKollegiumTargy, int? isEgymiTargy, int? isFelnottoktatasTargy, int? isMszgTargy, string angolNev, string nemetNev, string horvatNev, string romanNev, string szerbNev, bool? nincsTantargykategoria);
        DataSet GetFotargyak(int? kiveve = null);
        DataSet GetFotargyakByTanev(int tanevId);
        DataSet GetFotargyhozTartozoAltargyak(List<int> tantargyIdList);
        DataSet GetTanarTantargyaiByTanevCsoportositva(int tanevId, string egyebGroup, bool filterNincsBeloleOra = false);
        ITantargy GetTantargy();
        ITantargy GetTantargy(int id);
        DataSet GetTantargyakEgyesErtekelessel(int tanevId, int intezmenyId, List<int> tantargyIdList);
        DataSet GetTantargyakKiveveAltargyak(int? userId);
        DataSet GetTantargyakNincsBeloleOra(int tanevId);
        DataSet GetTantargyakSablonokkal(int tanevId);
        DataSet GetTantargyAMISablonhoz(int tanevId, int amiTantargySablonId);
        DataSet GetTantargyDataSet(int tanevId, bool isRendezoOszlopokKell = false);
        DataSet GetTantargyDataSet(int tanevId, int? tanarId, bool filterNincsBeloleOra = false);
        ITantargyNyelv GetTantargyNyelv();
        bool HasTantargyFotargyAltargy(int intezmenyId, int tanevId, int fotargyAltargyId);
        void Insert(ITantargy tantargy);
        void InsertNyelv(ITantargyNyelv tantargyNyelv);
        bool IsGyakorlatiTantargy(int tantargyId);
        bool TantargyKategoriaHasznalatbanVan(int targyKatId);
        (bool isOsztalyzattalErtekelheto, bool isSzovegesenErtekelheto, bool isSzazalekosanErtekelheto) GetErtekelesKorlatozasok(int tantargyId);
        DataSet GetTanuloAktualisanTanultTantargyai(int tanuloId, string magatartas, string szorgalom, List<int> tantargyIds = null, int? oktatasiNevelesiFeladatId = null);
        int? GetDualisKepzesTantargyId(int intezmenyId, int tanevId);
    }
}
