﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.Model.TantargyFelosztas;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.DataAccessManual.Util;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITantargyFelosztasDal
    {
        void Delete(IFoglalkozas entity);

        void TantargyfelosztasVisszamenolegesModositas(int intezmenyId, int tanevId, int felhasznaloId,
            TantargyFelosztasVisszamenolegesPCO ttf);

        DataSet GetEgyszerAdhatoErtekelesekTanatargyfelosztasModositasAlapjan(int intezmenyId, int tanevId,
            TantargyFelosztasVisszamenolegesPCO ttf);

        void UpdateOrarendiOraAfterTantargyfelosztasUpdate(int intezmenyId, int tanevId, int felhasznaloId,
            TantargyFelosztasVisszamenolegesPCO ttf);

        void RemoveOrarendiOraTTFRelation(int intezmenyId, int tanevId, int ttfId);

        DataSet TantargyfelosztasbanValtozoOrarendiOrak(int intezmenyId, int tanevId,
            TantargyFelosztasVisszamenolegesPCO ttf);

        void FizikaiTorlesTantargyfelosztas(int intezmenyId, int tanevId, int userId);

        DataSet GetFoglalkozasById(int TTFId);

        DataSet GetFoglalkozasDataById(int TTFId);

        DataSet GetTantargyFelosztasKapcsolatai(int TTFId, int tanevId);

        DataSet GetFoglalkozasokByOsztalyCsoport(int osztalyCsoportId, int tanevId);

        DataSet GetTanarAltalErtekelhetoCsoportok(int tanarId, int? tanevId, int szuperOsztalyfonok, DateTime date,
            string osztalyGroupName, string csoportGroupName);

        DataSet GetTanarDolgozatTantargyak(int tanarId, int? tanevId, int szuperOsztalyfonok, DateTime date);

        int GetTeremByFoglalkozas(int foglalkozasId);

        DataSet GetTantargyFelosztasokKereses(int? tanarId = null, int? csoportId = null, List<int> tantargyIds = null,
            int? targyKatId = null,
            int? foglalkozasTipusId = null, int? tanevId = null, int? evfolyamId = null, int? feladatKategoriaId = null,
            int? feladatellatasihelyId = null,
            int? felosztasId = null, double? oraszam = null, bool? isImportalt = null, bool osztalybontasokkal = false,
            bool kapcsolodoCsoportokkal = false,
            List<int> osztalyCsoportIds = null, int? oktatasiNevelesiFeladatId = null,
            bool isFromSzervezet = false);

        void GetOraszamSUM(DataSet ds, string commandText, List<CommandParameter> commandParameters);

        DataSet GetTTFToExport(int tanevId);

        DataSet GetTTFToExport(int tanevId, int? tanarId, int? csoportId, int? tantargyId, int? targyKatId,
            int? foglalkozasTipusId, int? feladatKategoriaId, int? feladatellatasiHelyId, int? evfolyamId,
            double? oraszam, bool? isImportalt, bool osztalybontasokkal, bool kapcsolodoCsoportokkal, bool isFromSzervezet);

        DataSet GetFormazottTTFExport(int intezmenyId, int tanevId, int formatMode, string azonosito);

        DataSet GetTanoranKivuliFoglalkozasokToExport(int tanev);

        void DeleteAllTargyFelosztas(int tanevId);

        DataSet GetTantargyFelosztasAdatok(int felosztasId);

        DataSet GetTantargyFoglalkozasai(int tantargyId, int tanevId);

        DataSet GetFoglalkozasok(List<int> csoportTipusok, int? tanarId = null);

        DataSet GetFoglalkozasok(int tanevId, int? tanarId = null, int? osztalyId = null,
            bool? isOsszefuggoSzakGyak = null, bool filterNincsBeloleOra = false, bool isKapcsolodoCsoportok = false);

        int? TantargyFelosztasLetezik(int tanarId, int osztalyCsoportId, int tantargyId, int? ttfId, int tanevId);

        DataSet GetFoglalkozasokForDDL(int tanarId, int tanevId);

        (int id, bool removeFromOrarendOra) CreateOrUpdateFelosztas(TantargyFelosztasDM dm, int intezmenyId, bool isForceInsert = false);

        DataSet ValidateTantargyfelosztasVisszamenolegesModositas(TantargyFelosztasVisszamenolegesPCO ttf);

        void HandleTanarValtozasOrarendiOrakon(int foglalkozasId);
    }
}
