﻿namespace Kreta.DataAccessManual.Interfaces
{
    using System;
    using System.Collections.Generic;
    using System.Data;
    using Kreta.DataAccess.Interfaces;
    using Kreta.Enums;

    public interface ITanuloCsoportDal
    {
        void Delete(int id, bool logikai = true);
        void Delete(ITanuloCsoport dto, bool logikai = true);
        void FullUpdate(ITanuloCsoport dto);
        void Update(ITanuloCsoport dto);
        ITanuloCsoport Get();
        ITanuloCsoport Get(int id);
        void Insert(ITanuloCsoport dto);

        DataSet FilterTanuloIsInClass(int tanevId, List<int> tanuloId, OktNevelesiKategoriaEnum? kategoriaTipus);
        DataSet GetTanulokOsztalyCSoport(int tanevId, List<int> tanuloId, OktNevelesiKategoriaEnum? kategoriaTipus);

        DataSet GetTanulokOsztalyai(IList<int> tanuloIdList);
        DataSet GetTanuloOsztalyCsoport(int tanevId, IEnumerable<int> tanuloIds, OktNevelesiKategoriaEnum? kategoriaTipus);
        DataSet GetTanulokOsztalyaiByTanuloIdp(int tanevId, IEnumerable<Guid> tanuloIdps);
        DataSet MindenOsztallyalRendelkezoTanulo(int tanevId, DateTime date);
        DataSet Osztalyok(int tanevId, OktNevelesiKategoriaEnum? kategoriaTipus = null);
        DataSet GetCsoportok(int tanevId, OktNevelesiKategoriaEnum? kategoriaTipus = null, bool dualisKepzesIsEnabled = false, bool csakDualis = false, int? szervezetId = null);
        DataSet OsztalyTanuloi(int tanevId, List<int> osztalyIds, bool kovTanev = false, DateTime? datum = null, bool pIsJogviszonyKezeles = false);
        DataSet OsztalyTanuloi(int tanevId, List<int> osztalyIds, DateTime datum);
        DataSet CsoportTanuloi(int tanevId, int csoportId, DateTime pDatum, bool isKovTanev);
        DataSet OsztalyNelkuliTanulok(int tanevId, OktNevelesiKategoriaEnum kategoriaTipus);
        DataSet GetDualisTanulok(int tanevId, DateTime pLekerdezesDatum, int? pSzervezetId = null);
        DataSet OsszesTanulo(int tanevId, bool isKovTanev);
        DataSet KiiratkoztatottTanulok(OktNevelesiKategoriaEnum feladatKategoria, int tanevId);
        DataSet KiiratkoztatottTanulok(int tanevId, OktNevelesiKategoriaEnum feladatKategoria);
        DataSet KiiratkoztatottTanulok(int kisoroltTanevId, int besorolasTanevId);

        DataSet GetOsztalyEgyeniCsoportok(int tanevId, int osztalyId);
        DataSet GetOsztalyCsoportokByNev(int tanevId, string osztalyCsoportNev);
        DataSet GetTanuloByTanevAndOsztalyAndKiiratkoztatasDatum(int tanevId, int? tanuloId = null, int? osztalyId = null, DateTime? kiiratkoztatasDatum = null);
        DataSet GetTanuloOsztalyBontasosCsoportKapcsolatai(int tanevId, int tanuloId, int osztalyId);
        DataSet GetTanulokAdatai(List<int> tanuloIdList);
        DataSet GetFelvettNebulok();
        DataSet GetFelvettEsMegNemLetezoKovTanevesNebulok(bool useNemFelvettStatusz);
        void RemoveTanuloMulasztasByDate(int tanuloId, int fromOsztalyId, DateTime date);
        int Check4TValidacio(int validationType, string vezeteknev, string utonev, string anyjaNeve, string szuletesiHely,
            DateTime szuletesiDatum, int? userId, int tanevId, string elotag);
        int CheckOktatasiAzonosito(string oktatasiAzonosito, int tanevId);
        DataSet GetKovTanuloByAktTanulo(int tanevId, int aktTanuloId);
        int GetJogviszonyLimit(int tanevId, OktNevelesiKategoriaEnum kategoriaTipus);

        DataSet GetTanuloOsztalyKapcsolatok(int tanevId, int tanuloId, DateTime datum,
            OktNevelesiKategoriaEnum kategoriaTipus);

        DataSet GetTanuloCsoportDataSet(int tanevId, int? oktNevelesiKategoriaId = null);
        DataSet GetFeladatkategoriabaTartozoTanuloCsoportok(int tanevId, int tanuloId, int osztalyId);
        bool IsTanuloJogviszonyKetDatumKozott(int tanevId, int tanuloId, DateTime kezdete, DateTime vege, int? feladatKategoriaId = (int)OktNevelesiKategoriaEnum.NevelesOktatas);
        DataSet GetJogviszonyLimitList(int tanevId);
        DataSet GetOsztalybaNemSoroltTanulok(DateTime kisorolasDatum, int tanevId, bool isLeptetes, bool pIsJogviszonyKezeles = false);
        int GetTanuloOsztalybaSorolasainakSzama(int tanuloId, int tanevId, OktNevelesiKategoriaEnum kategoriaTipus);
    }
}
