﻿using System;
using System.Collections.Generic;
using System.Data;
using Kreta.DataAccess.Interfaces;
using Kreta.DataAccessManual.ParameterClasses;
using Kreta.Enums.ManualEnums;

namespace Kreta.DataAccessManual.Interfaces
{
    public interface ITanuloErtekelesDal
    {
        void AddTanuloErtekelesNyelv(ITanuloErtekeles ertekeles, ITanuloErtekelesNyelv nyelv);
        bool CheckTanuloListEgyszerAdhatoTanuloErtekelesValidation(Dictionary<int, int?> tanuloErtekelesDictionary, int tipusId, int? tantargyId, DateTime? datum, int feladatKategoriaId);
        void Delete(int id);
        void FullUpdate(ITanuloErtekeles dto);
        ITanuloErtekeles Get();
        ITanuloErtekeles Get(int id);
        DataSet GetAllSchemaErtekelesNotification(DateTime date);
        DataSet GetAtlag(int osztalyCsoportId, int tantargyId, int tanevId, AtlagMegjelenitesTipus atlagMegjelenitesTipus, AtlagbaBeleszamitoOsztalyTipus atlagbaBeleszamitoOsztalyTipus, DateTime? datum = null);
        DataSet GetDolgozatErtekelesTemak(int intezmenyId, int tanevId, int? osztalyCsoportId, int? tantargyId);
        DataSet GetDolgozatReszletekDataSet(int? osztalyCsoportId, int? tantargyId, string ertekelesTema, DateTime? datum);
        DataSet GetErtekelesDolgozatAtlagDataSet(int intezmenyId, int tanevId, DolgozatokAtlagaSearchPco searchPco);
        DataSet GetLegfrissebbTanuloErtekelesDataSet(int intezmenyId, int tanevId, int tanuloId, int kesleltetettMegjelenitesOraszam);
        DataSet GetTanuloErtekelesDataSetByFotargyAltargy(int intezmenyId, int tanevId, int tanarId, int tanuloId, int fotargyAltargyId, DateTime? datum, int feladatKategoriaId);
        DataSet GetTanuloErtekelesDataSetByMagatartasSzorgalom(int tanevId, int tanarId, int osztalyCsoportId, DateTime? datum);
        DataSet GetTanuloErtekelesDataSetByTantargy(int tanevId, int tanarId, int tantargyId, int osztalyCsoportId, DateTime? datum, bool isFromSzervezet);
        DataSet GetTanuloErtekelesDataSetByTanulo(int intezmenyId, int tanevId, int? tanarId, int tanuloId, DateTime? datum, int oktatasiNevelesiFeladatId, int feladatKategoriaId);
        DataSet GetTanuloErtekelesDetailDataSet(int tanevId, int tanuloId, int? tantargyId, bool showToroltElemek, int? tanarId, int ertekelesMegjelenesFajtaId, DateTime? datum, int feladatKategoriaId, int? oktatasiNevelesiFeladatId, bool isDualisKepzesEnabled);
        DataSet GetTanuloErtekelesListDataSet(TanuloErtekelesListPco tanuloErtekelesListPco, bool utolagosOsztalyszures = false);
        DataSet GetTantargyiAtlagListDataSet(int tanevId, List<int> tantargyIds, List<int> tanuloIds, int? oktatasiNevelesiFeladatId = null);
        void Insert(ITanuloErtekeles dto);
        bool IsTanuloErtekelt(int intezmenyId, int tanevId, DateTime datum, int? ertekelesModId, int tipusId, int tantargyId, string tema, int tanuloId, int? osztalyzatId, int? szazalek, string ertekelesSzovege);
        void RemoveAllTanuloErtekelesNyelv(ITanuloErtekeles ertekeles);
        void SetErtekelesAsKikuldott(IEnumerable<int> idList);
        void UpdateTantargyAtlag(int intezmenyId, int tanevId, int felhasznaloId);
        void UpdateTantargyAtlagByTanuloTantargy(int intezmenyId, int tanevId, int felhasznaloId, int tanuloId, int tantargyId, int oktatasNevelesiFeladatId);
        void UpdateAtlagByOsztalyCsoportTantargy(int intezmenyId, int tanevId, int felhasznaloId, int osztalyCsoportId, int? tantargyId);
        void Update(ITanuloErtekeles dto);
        DataSet ValidateTanuloListTanuloMentesseg(List<int> tanuloIdList, int tantargyId, DateTime ertekelesDatum);
        DataSet GetErtekelesekDataSet(int tantargyId, int osztalyCsoportId, int? tanuloId = null);
        DataSet GetTanuloErtekeleseiDataSet(int tanuloId, int tantargyId, int osztalyCsoportId);
    }
}
